Package: methylPipe
Type: Package
Title: Base resolution DNA methylation data analysis
Version: 1.46.0
Date: 2025-07-22
Authors@R: c(person("Mattia", "Pelizzola", role = "aut"), person("Kamal", "Kishore", role = "aut"), person("Mattia", "Furlan", email = "mattia.furlan@iit.it", role = c("ctb","cre")))
Description: Memory efficient analysis of base resolution DNA methylation data in both the CpG and non-CpG sequence context. Integration of DNA methylation data derived from any methodology providing base- or low-resolution data.
License: GPL(>=2)
LazyLoad: yes
Imports: marray, gplots, IRanges, BiocGenerics, Gviz,
        GenomicAlignments, Biostrings, parallel, data.table, Seqinfo,
        S4Vectors
Depends: R (>= 3.5.0), methods, grDevices, graphics, stats, utils,
        GenomicRanges, SummarizedExperiment (>= 0.2.0), Rsamtools
Suggests: BSgenome.Hsapiens.UCSC.hg18,
        TxDb.Hsapiens.UCSC.hg18.knownGene, knitr, MethylSeekR
VignetteBuilder: knitr
biocViews: MethylSeq, DNAMethylation, Coverage, Sequencing
git_url: https://git.bioconductor.org/packages/methylPipe
git_branch: RELEASE_3_23
git_last_commit: 2bc3fc9
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 23:14:44 UTC; biocbuild
Author: Mattia Pelizzola [aut],
  Kamal Kishore [aut],
  Mattia Furlan [ctb, cre]
Maintainer: Mattia Furlan <mattia.furlan@iit.it>

                                        # chr
setGeneric('chr', function(object) standardGeneric('chr'))
setMethod('chr','GEcollection', function(object)
          as.character(seqnames(object)))
                                        # binmC
setGeneric('binmC', function(object)
           standardGeneric('binmC'))
setMethod('binmC', 'GEcollection', function(object)
          assays(object)[["binmC"]])
                                        # binC
setGeneric('binC', function(object)
           standardGeneric('binC'))
setMethod('binC', 'GEcollection', function(object)
          assays(object)[["binC"]])

                                        # binrC
setGeneric('binrC', function(object)
           standardGeneric('binrC'))
setMethod('binrC', 'GEcollection', function(object)
          assays(object)[["binrC"]])

                                        # binscore
setGeneric('binscore', function(object)
           standardGeneric('binscore'))
setMethod('binscore', 'GEcollection', function(object)
          assays(object)[["binscore"]])

                                        # set binscore
setGeneric('binscore<-', function(object, value)
           standardGeneric('binscore<-'))
setMethod('binscore<-', 'GEcollection', function(object, value) {
    if(!is.numeric(value))
        stop("The binscore values has to be numeric")
    assays(object)[["binscore"]] <- value
    object
})

                                        # nbins
setGeneric('nbins', function(object)
           standardGeneric('nbins'))
setMethod('nbins', 'GEcollection', function(object)
          ncol(object))

                                        # length
setMethod('length', 'GEcollection', function(x)
          length(rowRanges(x)))

                                        # show
setMethod('show', 'GEcollection', function(object) {
    cat("S4 Object of class GEcollection; ")
    message()
    print(rowRanges(object))
    cat("\nbinmC : ")
    if(!is.null(assays(object)[["binmC"]])) cat('ok')
    else cat('NA')
    cat("\nbinC : ")
    if(!is.null(assays(object)[["binC"]])) cat('ok')
    else cat('NA')
    cat("\nbinrC : ")
    if(!is.null(assays(object)[["binrC"]])) cat('ok')
    else cat('NA')
    cat("\nbinscore : ")
    if(length(which(is.na(assays(object)[["binscore"]])))
       != length(assays(object)[["binscore"]])) cat('ok')
    else cat('NA')
    cat('\n')
})

                              # function to determine hmC level from mlml output file

process.hmc <- function(file, output_folder, Coverage){
    if(!is.character(file))
        stop('file has to be of class character ..')
    if(!is.character(output_folder))
        stop('output_folder has to be of class character ..')
    if(!is(Coverage,"GRanges"))
        stop('Coverage has to be of class GRanges with column name coverage..')

    output_folder <- normalizePath(output_folder)  
    sample_name <- unlist(strsplit(file, split=".txt"))
    output.files <- list()
    temp_data <- fread(file, sep="\t", header=FALSE)
    temp_data_gr <- GRanges(temp_data[,1],IRanges(temp_data[,2], temp_data[,2]))
    ov <- findOverlaps(temp_data_gr, Coverage)
    mcols(temp_data_gr)$coverage <- 0
    ind1 <- queryHits(ov)
    ind2 <- subjectHits(ov)
    mcols(temp_data_gr)$coverage[ind1] <- mcols(Coverage)$coverage[ind2]
    temp_data[,4] <- round((temp_data[,4]*mcols(temp_data_gr)$coverage))
    temp_data[,5] <- round((temp_data[,5]*mcols(temp_data_gr)$coverage))
    temp_data[,6] <- round((temp_data[,6]*mcols(temp_data_gr)$coverage))
    ind <- which(temp_data[,7]==0)
    temp_data <- temp_data[ind,]
    temp_data_CpG <- temp_data[,c(1,2,4,6)]
    temp_data_hmC <- temp_data[,c(1,2,5,6)]
    filename <- file.path(output_folder,
                          paste(sample_name, "_", "CpG", ".txt", sep=""))
    write.table(temp_data_CpG, file=filename)
    filename <- file.path(output_folder,
                          paste(sample_name, "_", "hmC", ".txt", sep=""))
    write.table(temp_data_hmC, file=filename)
}

                                        # function to determine the methylation

meth.call <- function(files_location, output_folder, no_overlap, read.context, Nproc){
    if(!is.character(files_location))
        stop('files_location has to be of class character ..')
    if(!is.character(output_folder))
        stop('output_folder has to be of class character ..')
    if(!is.logical(no_overlap))
        stop('no_overlap has to be of class logical ..')
    if(!is.character(read.context))
        stop('read.context has to be of class character ..')
    if(!is.numeric(Nproc))
        stop('Nproc has to be of class numeric ..')
    
    files_location <- normalizePath(files_location)
    output_folder <- normalizePath(output_folder)

                                        # read.type
    if( !( read.context %in% c("CpG","All")))
        stop("wrong 'read.context' argument supplied, only 'CpG' or 'All' accepted")

                                        # list of input sam files
    all_files <- list.files(path = files_location, pattern = ".sam")
    sample_name <- unlist(strsplit(all_files, split=".sam"))

                                        # list of output files
    output.files <- list()
    output.files[[read.context]] <- file.path(output_folder,
                                              paste(sample_name, "_", read.context, ".txt", sep=""))
                                        # creation of system command
    read.files <- file.path(files_location, all_files)
    perl.arguments <- paste("--file", read.files, "--sam_type paired_sam")
    if(read.context == "CpG" )
        {perl.arguments <- paste(perl.arguments, "--CpG", output.files[["CpG"]] )}
    if(read.context == "All" )
        {perl.arguments <- paste(perl.arguments, "--All", output.files[["All"]] )}
    if(no_overlap){perl.arguments <- paste(perl.arguments, "--no_overlap" )}
                                        # location of the perl script
    perl.loc <- (system.file("exec", "methinfo.pl", package="methylPipe"))
    cmd <- paste("perl", perl.loc, perl.arguments)
                                        # then call perl to process the file
    message(    )
    message("Extracting methylation information from input SAM files and creating output files for each sample...")
    message()
    runperl <- function(x)
        {
            status <- try(system(x))
            if(status != 0)
                {stop("\nError in methylation calling...\n
                Check if it is a sorted Bismark SAM file\n")}
    }

    parallel::mclapply(cmd, runperl, mc.cores=Nproc, mc.preschedule=TRUE)
    
    message("Creating temporary BAM files from input SAM files...")
    message()
    setwd(output_folder)
    system('mkdir tempBAM')
    temp_folder <- paste0(output_folder,"/tempBAM")

    for (i in 1:length(all_files))
        asBam(file.path(files_location, all_files[i]), destination=file.path(temp_folder, sample_name[i]), overwrite=TRUE)

    message("Creating uncovered regions objects for each sample from BAM files...")
    message()
    bam.files <- file.path(path = temp_folder, paste(sample_name, ".bam", sep=""))
    for (i in 1:length(all_files))
        {
            aln_file <- bam.files[i]
            aln <- readGAlignments(aln_file)
            cov <- coverage(aln)
            #ind <- sapply(cov, function(x)(length(which(runValue(x)== 0))))
            ind <- sapply(cov, function(x)(length(runValue(x))))
            cov <- cov[which(ind > 1)]
            uncov_GR <- as(cov, "GRanges")
            uncov_GR <- uncov_GR[mcols(uncov_GR)$score== 0]
            filename <- file.path(output_folder, paste0(sample_name[[i]],"_uncov", ".Rdata"))
            Objectout <- paste0(sample_name[[i]],"_uncov")
            assign(Objectout, uncov_GR)
            save(list=Objectout, file=filename)
        }
    message('Removing all temporary BAM files...')
    message()
    str <- paste("rm -r","tempBAM")
    system(str)
    message('Methylation info and Uncovered regions output files created for each sample in output_folder...')
    message()
    message("Processing done Successfully...")
    message()
}

#### combining reads of replicates within a single group 
pool.reads <- function(files_location)
{
  if(!is.character(files_location))
    stop('files_location has to be of class character ..')
  files_location <- normalizePath(files_location)
  all_files <- list.files(files_location,pattern=".txt")
  setwd(files_location)
  cmd <- paste("cat", paste(all_files, collapse= " "), ">", paste0(files_location, "/", "sample_merge.txt"))
  system(cmd)
  python.loc <- system.file("exec", "pool_reads.py", package="methylPipe")
  merge_file_loc <- paste0(files_location, "/", "sample_merge.txt")
  cmd <- paste("python", python.loc, merge_file_loc, ">",paste0(files_location, "/","sample_merge_pooled.txt"))
  system(cmd)
  cmd <- paste("sort -k1,1 -k2,4n", paste0(files_location, "/", "sample_merge_pooled.txt") , ">", 
               paste0(files_location, "/", "sample_merge_pooled_sort.txt"))
  system(cmd)
  cmd <- paste("rm","*_merge.txt")
  system(cmd)
  cmd <- paste("rm","*_merge_pooled.txt")
  system(cmd)
}


tabixdata2GR <- function(x) {
    if(length(x) == 0) return(NA)
    temp <- strsplit(x, split="\t")
    mat  <- matrix(unlist(temp), ncol=7, byrow=TRUE)
    df   <- as.data.frame(mat, stringsAsFactors=FALSE)
    df_gr <- GRanges(df[,1], IRanges(as.numeric(df[,2]), as.numeric(df[,2])),
                     strand=df[,3], Context=df[,4], C=as.numeric(df[,5]), T=as.numeric(df[,6]), Significance=as.numeric(df[,7]))
    rm(df)
    rm(mat)
    return(df_gr)
}

BSdata <- function(file, uncov, org) {
    bsdata <-  new('BSdata', file=file, uncov=uncov, org=org)
    return(bsdata)
}


BSdataSet <-  function(org, group, ...) {
    Objname <- names(list(...))
    if(!is.null(Objname))
        new("BSdataSet", org=org, group=group, Objlist=list(...), names=names(list(...)))
    else stop('define the names for the Objects in the arguments..')
}


GElist <- function(...)
{
    Objname <- names(list(...))
    if(!is.null(Objname))
        new("GElist", Objlist=list(...), names=names(list(...)))
    else stop('define the names for the Objects in the arguments..')
}


BSprepare <-  function(files_location, output_folder, tabixPath, bc=1.5/100) {
    if(!is.character(files_location))
        stop('files_location has to be of class character ..')
    if(!is.character(output_folder))
        stop('output_folder has to be of class character ..')
    if(!is.character(tabixPath))
        stop('tabixPath has to be of class character ..')
    if(!file.exists(paste(tabixPath, '/tabix', sep='')))
        stop('tabix not found at tabixPath ..')
    if(!file.exists(paste(tabixPath, '/bgzip', sep='')))
        stop('bgzip not found at tabixPath ..')
    
    files_location <- normalizePath(files_location)
    output_folder <- normalizePath(output_folder)
    tabixPath <- normalizePath(tabixPath)
    binomTestMulti <- function(mat, maxN=50, p=bc, bh=TRUE) {
        bmat <- matrix(NA, maxN, maxN)
        for(i in 1:maxN) {
            for(j in i:maxN) bmat[i,j] <- binom.test(x=i, n=j, p=p,
                                                     alternative='greater')$p.value
        }
        pVfun <-  function(x) {
            if(x[2] < (maxN+1)) return(bmat[x[1], x[2]])
            else return(binom.test(x=x[1], n=x[2], p=p,
                                   alternative='greater')$p.value)
        }
        pValues <-  apply(mat, 1, pVfun)
        if(bh) pValues <-  p.adjust(pValues, method='BH')
        pValues <-  -round(10*log10(pValues))
        return(pValues)
    }
    
    
    ####### checking for the chromosome column ##########
    all_files <- list.files(path = files_location, pattern = ".txt")
    for (i in 1:length(all_files))
    {
      path <- paste0(files_location,"/",all_files[[i]])
      temp_data <- fread(path,nrows=10)
      if(length(grep("chr",temp_data$V1))==0)
      {
        cmd <- paste("sed -i 's/\"//g'",path)
        system(cmd)
        cmd <- paste("sed -i 's/^/chr/'",path) 
        system(cmd)
      }
    }
    
    ############### sorting chromosome files ############
    
    sample_name <- unlist(strsplit(all_files, split=".txt"))
    cmd <- paste("sort -k1,1 -k2,4n", paste0(files_location, "/", all_files) , ">", 
                 paste0(files_location, "/", sample_name,"_sort.txt"))
    sapply(cmd,system)
    cmd <- paste("mv", paste0(files_location, "/", sample_name,"_sort.txt"), 
                 paste0(files_location, "/", sample_name,".txt"))
    sapply(cmd,system)
    
    ######################################################
    
    for(i in 1:length(all_files)) {
        filecg <- all_files[i]
        message(filecg)
        filemC <- paste0(files_location, "/", filecg, '.mC')
        str <- paste('cut -f5,6', paste0(files_location, "/", filecg), '>', filemC)
        system(str)
                                        # computing binomial pvalues
        mCdat <- fread(filemC)
        mCdat <- as.matrix(mCdat)
        mCdat[,2] <- mCdat[,1]+ mCdat[,2]
        pV <- binomTestMulti(mCdat, p=bc)
                                        # attaching pvalues

        filepV <- paste0(filemC, '.pvalues')
        fileTabix <- paste0(files_location, "/", sample_name[i], '_tabix.txt')
        write(pV, file=filepV, ncolumns=1)
        str <- paste('paste', paste0(files_location, "/", filecg), filepV, '>', fileTabix)
        system(str)
        system(paste('rm', filepV, filemC))
    }
                                        # concatenating, compressing and building tabix index
    message('postprocessing ..')
    Tabix_files <- list.files(path = files_location, pattern = "_tabix.txt")
                                        
                                        # generating the TABIX compressed file
    for(filetb in Tabix_files) {
        filetb_name <- unlist(strsplit(filetb,split=".txt"))
        str <- paste('cat', paste0(files_location, "/", filetb), '>', 
                     paste0(output_folder, "/", filetb_name,"_out.txt"))
        system(str)
        str <- paste0(tabixPath, '/bgzip ', output_folder, "/", filetb_name,"_out.txt")
        system(str)
                                        # generating the TABIX index file
        fileoutgz <- paste0(output_folder, "/", filetb_name,"_out.txt", '.gz')
        str <- paste(tabixPath, '/tabix -s 1 -b 2 -e 2 -f ', fileoutgz, sep='')
        system(str)
    }
}


                                        # splitting chromosomes in N Mb regions ..
splitChrs <- function(chrs, org) {
    if(!is(org,"BSgenome") & !is(org,"list"))
        stop('org has to be either a list or an object of class BSgenome ..')
    chrs_org <- seqnames(org)
    if(any(!chrs %in% chrs_org))
        stop('This is not a valid chromosome .. ')
    chrL <- seqlengths(org)[chrs]
    splitDf <- data.frame(chrs, 1, chrL, row.names = NULL, stringsAsFactors=FALSE)
    colnames(splitDf) <- c('chr','start','end')
    return(splitDf)
}

                                        # fisher's method to determine a Pvalue based on a set of Pvalues
chiCombP <- function(Pvalues) {
    chistat <- -2*(sum(log(Pvalues)))
    chiP <- 1-pchisq(chistat, df=2*length(Pvalues))
    return(chiP)
}


                                        # consolidating DMRs ..

consolidateDMRs <- function(DmrGR, pvThr=0.05, MethDiff_Thr=NULL, log2Er_Thr=NULL,
                            GAP=0, type=NULL, correct=FALSE){
    if(!is(DmrGR, "GRanges"))
        stop('DmrGR has to be of class GRanges ..')
    if(!is.numeric(pvThr))
        stop('pvThr has to be of class numeric ..')
    if(!is.null(MethDiff_Thr) & !is.numeric(MethDiff_Thr))
        stop('MethDiff_Thr has to be either NULL or of class numeric ..')
    if(!is.null(log2Er_Thr) & !is.numeric(log2Er_Thr))
      stop('log2Er_Thr has to be either NULL or of class numeric ..')
    if(!is.numeric(GAP))
        stop('GAP has to be of class numeric ..')
    if(!is.null(MethDiff_Thr) & any(!type %in% c("hyper","hypo")))
        stop('type has to be either NULL or one of hyper and hypo ..')
    if(!is.logical(correct))
        stop('correct has to be of class logical ..')

    if(correct) mcols(DmrGR)$pValue= p.adjust(mcols(DmrGR)$pValue, method='BH')
    sInds <- which(mcols(DmrGR)$pValue <= pvThr)
    if(!is.null(MethDiff_Thr)) {
                                        # selecting based on methylation diff
        mInds <- which(abs(mcols(DmrGR)$MethDiff_Perc) >= MethDiff_Thr)
        sInds <- IRanges::intersect(sInds, mInds)
    }
    if(!is.null(log2Er_Thr)) {
                                        # selecting based on log2enrichment
        eInds <- which(abs(mcols(DmrGR)$log2Enrichment) >= log2Er_Thr)
        sInds <- IRanges::intersect(sInds, eInds)
    }
    if(length(sInds) == 0) return(NULL)
    DmrGR <- DmrGR[sInds,]
    if(!is.null(type))
    {
      if(type=="hypo")
        DmrGR <- DmrGR[mcols(DmrGR)$MethDiff_Perc < 0]
      else
        DmrGR <- DmrGR[mcols(DmrGR)$MethDiff_Perc > 0]
    }

                                        # building a GRanges for selected DMRs

    joinDMR <- function(query, Gap=0, fun=chiCombP) {
        if(!is.numeric(Gap))
            stop('Gap has to be of class numeric .. ')
        if(class(fun) != 'function')
            stop('fun has to be of class function .. ')
        commonChrs <- unique(as.character(seqnames(query)))
        resIR_gr <- GRanges()
        for(chrom in commonChrs) {
            queryF <- query[seqnames(query) == chrom]
            Pv <- mcols(queryF)$pValue
            MethDiff <-  mcols(queryF)$MethDiff_Perc
            Enrichment <-  mcols(queryF)$log2Enrichment
                                        # extracting IRanges from the dataframe
            IR1 <- IRanges(start(queryF), end(queryF))
            IR2 <- IR1
            if(Gap > 0) {
                                        # Gap are added on each side of the genomic regions
                                        # they will be taken back after the intersection
                start(IR1) <- start(IR1) - Gap
                end(IR1) <- end(IR1) + Gap
                start(IR2) <- start(IR2) - Gap
                end(IR2) <- end(IR2) + Gap
            }
            iIR <- IRanges::intersect(IR1, IR2)
            if(length(iIR) == 0) next
            if(Gap > 0) {
                start(iIR) <- start(iIR) + Gap
                end(iIR) <- end(iIR) - Gap
            }
            combPv <- rep(NA, length(iIR))
            combMethDiff <- rep(NA, length(iIR))
            combEnrichment <- rep(NA, length(iIR))
                                        # determining which IR elements were combined in iIR
            result1 <- findOverlaps(iIR, IR1)
            res1 <- cbind(queryHits(result1), subjectHits(result1))
            result2 <- findOverlaps(iIR, IR2)
            res2 <- cbind(queryHits(result1), subjectHits(result1))
            for(uind in unique(res2[,1])) {
                inds <- which(res2[,1] == uind)
                IR2ind <- res2[inds,2]
                Pvs <- Pv[IR2ind]
                Meth <- MethDiff[IR2ind]
                Enr <- Enrichment[IR2ind]
                combPv[uind] <- do.call('fun', list(Pvs))
                combMethDiff[uind] <- do.call(mean, list(Meth))
                combEnrichment[uind] <- do.call(mean, list(Enr))
            }
            suppressWarnings(resIR_gr <- append(resIR_gr, GRanges(Rle(chrom), IRanges(start(iIR), end(iIR)),
                                                                  pValue=round(combPv,3), MethDiff_Perc=round(combMethDiff,3),
                                                                  log2Enrichment=round(combEnrichment,3))))
        }
                                        # appending the new iIR to those generated for the other chromosomes
        zeroWinds <- which(width(resIR_gr) == 1)
        if(length(zeroWinds) > 0) resIR_gr <- resIR_gr[-zeroWinds,]
        resIR_gr
    }

    dmrGRanges <- joinDMR(DmrGR, Gap=GAP)
    return(dmrGRanges)
}


                                        # retrieve mC calls for genomic regions given a BSdata object for a sample

mapBSdata2GRanges <- function(GenoRanges, Sample, context='all', mC=1, depth=0,
                              pValue=1) {
    if(!is(GenoRanges, "GRanges"))
        stop('GenoRanges has to be of class GRanges ..')
    if(!is(Sample, "BSdata"))
        stop('Sample has to be of class BSdata ..')
    if(length(which(!(context %in% c('all','CG','CHG','CHH')))) > 0)
        stop('context has to be either all or a combination of CG, CHG, and CHH ..')
    if(!is.numeric(mC) & mC < 0 )
        stop('mC has to be of class numeric and positive..')
    if(!is.numeric(depth))
        stop('depth has to be of class numeric ..')
    if(!is.numeric(pValue))
        stop('pValue has to be of class numeric ..')
    if(pValue > 1)
        stop('pValue has to be lower than 1 ..')


                                        # querying TABIX indexed files based on the tabix seqnames,
                                        # assigning NA to GRanges regions in chrs not represented
    tabixChrs <- seqnamesTabix(Sample@file)
    representedChr <- which(as.character(seqnames(GenoRanges)) %in% tabixChrs)
    if(length(representedChr) == 0)
      {
      res <- as.list(rep(NA, length(GenoRanges))) 
      return(res)
      }
    otherChr <- which(!(as.character(seqnames(GenoRanges)) %in% tabixChrs))
    if(length(otherChr) > 0) res <- as.list(rep(NA, length(GenoRanges)))

    regions <- GenoRanges[representedChr,]
    resScan <- scanTabix(Sample@file, param=regions)
    resScan <- lapply(resScan, tabixdata2GR)
    if(length(otherChr) > 0) res[representedChr] <- resScan
    else res <- resScan
                                        # filtering results
    filterFun <- function(gr, context, mC, depth, pValue) {
        indsList <- list()
        if(context[1] != 'all') indsList$cl <- which(mcols(gr)$Context %in% context)
        if(mC > 0) indsList$mC <- which(mcols(gr)$C > mC)
        if(depth > 0) indsList$d <- which((mcols(gr)$C+mcols(gr)$T) > depth)
        pV <- -10*log10(pValue)
        if(pValue < 1) indsList$p <- which(mcols(gr)$Significance > pV)
        tableInds <- table(unlist(indsList))
        inds <- names(tableInds)[tableInds == length(indsList)]
        if(is.null(inds) | length(inds) == 0) return(NA)
        return(gr[as.numeric(inds),])
    }


    if(context != 'all' | mC > 1 | depth > 0 | pValue < 1) {
        NAinds <- as.numeric(which(is.na(res)))
        if(length(NAinds) > 0) {
            res[-NAinds] <- lapply(res[-NAinds], filterFun, context, mC, depth, pValue)

        }
        else res <- lapply(res, filterFun, context, mC, depth, pValue)
    }
    return(res)
}


                                        # for  GenomicRanges with N bins, extract the information
                                        # of the Genomic ranges for a given bin

extractBinGRanges <- function(GenoRanges, bin, nbins) {
    if(!is(GenoRanges, "GRanges"))
        stop('GenoRanges has to be of class GRanges ..')
    if(!is.numeric(bin) | length(bin) != 1 | is.na(bin))
        stop(' bin has to be a single non-NA integer ')
    if(!is.numeric(nbins) | length(nbins) != 1 | is.na(nbins))
        stop(' nbins has to be a single non-NA integer ')
    if( bin < 1 | bin > nbins)
        stop(' bin has to be between 1 and nbins ')
    binsize <- round(width(GenoRanges)/nbins)
    starts <- start(GenoRanges) + (bin-1)*binsize
    gnew <- GRanges(as.character(seqnames(GenoRanges)),
                    IRanges(starts, width=binsize),
                    strand=as.character(strand(GenoRanges)))
    return(gnew)
}


                                        # As in mapBSdata2GRanges, but returns mC calls
                                        # within each bin of each Genomic region

mapBSdata2GRangesBin <- function(GenoRanges, Sample,
                                 context='all', mC=1, depth=0, pValue=1, nbins){
    if(!is(GenoRanges, "GRanges"))
        stop('GenoRanges has to be of class GRanges ..')
    if(!is(Sample,'BSdata'))
        stop('Sample has to be of class BSdata ..')
    if(length(which(!(context %in% c('all','CG','CHG','CHH')))) > 0)
        stop('context has to be either all or a combination of CG, CHG, and CHH ..')
    if(!is.numeric(mC) & mC < 0 )
        stop('mC has to be of class numeric and positive..')
    if(!is.numeric(depth))
        stop('depth has to be of class numeric ..')
    if(!is.numeric(pValue))
        stop('pValue has to be of class numeric ..')
    if(pValue > 1)
        stop('pValue has to be lower than 1 ..')
    if(!is.numeric(nbins))
        stop('nbins has to be of class numeric ..')
    resList <- list()
    if(nbins == 1)
        resList[[1]] <- mapBSdata2GRanges(GenoRanges, Sample, context)
    else
        {
            for(bin in 1:nbins) {
                gel <- extractBinGRanges(GenoRanges=GenoRanges, bin=bin, nbins=nbins)
                resList[[bin]] <- mapBSdata2GRanges(GenoRanges=gel, Sample=Sample,
                                                    context, mC, depth, pValue)
          }
        }
    resrev <- list()
    for(GEind in 1:length(GenoRanges)) resrev[[GEind]] <-
        lapply(resList, function(x) x[[GEind]])
    return(resrev)
}


                                        # get genomic Cxx positons for a series of genomic regions
getCpos <- function(GenoRanges, seqContext='all', nbins, org) {
    if(!is(GenoRanges, "GRanges"))
         stop('GenoRanges has to be of class GRanges ..')
    if(!(seqContext %in% c('all','CG','CHG','CHH')))
        stop('seqContext has to be one of all, CG, CHG or CHH ..')
    if(!is.numeric(nbins))
        stop('nbins has to be of class numeric ..')
    if(!is(org,"BSgenome"))
        stop('org has to be of class BSgenome ..')
    chrs <- as.character(seqnames(GenoRanges))
    if(length(which(!(unique(chrs) %in% names(org)))) > 0)
        stop('Object covers chromosomes not available in org ..')

    resList <- as.list(rep(NA, length(GenoRanges)))
    Nbins <- nbins
    for(Chr in unique(chrs)) {
        chrinds <- which(as.character(seqnames(GenoRanges)) == Chr)
        GenoRangesChr <- GenoRanges[seqnames(GenoRanges) == Chr]
        chrseq <- unmasked(org[[Chr]])
        if(seqContext != 'all') resList[chrinds] <-
            getCposChr(GenoRanges= GenoRangesChr, seqContext=seqContext,
                       chrseq=chrseq, Nbins)
        else {
            resCG <- resList[chrinds] <- getCposChr(GenoRanges= GenoRangesChr,
                                                    seqContext='CG', chrseq=chrseq, Nbins)
            resCHG <- resList[chrinds] <- getCposChr(GenoRanges= GenoRangesChr,
                                                     seqContext='CHG', chrseq=chrseq, Nbins)
            resCHH <- resList[chrinds] <- getCposChr(GenoRanges= GenoRangesChr,
                                                     seqContext='CHH', chrseq=chrseq, Nbins)
            resALL <- resCG
            for(i in 1:length(resALL)) {
                if(Nbins > 1) { for(bin in 1:Nbins)
                                    resALL[[i]][[bin]] <- sort(c(unlist(resCG[[i]][[bin]]),
                                                                 unlist(resCHG[[i]][[bin]]), unlist(resCHH[[i]][[bin]]))) }
                else resALL[[i]][[1]] <- sort(c(unlist(resCG[[i]]),
                                                unlist(resCHG[[i]]), unlist(resCHH[[i]])))
            }
            resList <- resALL
        }
    }
    return(resList)
}


                                        # get genomic Cxx positons for a series of genomic regions on a given chr seq

getCposChr <- function(GenoRanges, seqContext, chrseq, nbins) {
    if(length(unique(as.character(seqnames(GenoRanges)))) > 1)
        stop('GenoRanges maps to several chromosomes ..')
    if(!(seqContext %in% c('CG','CHG','CHH')))
        stop('seqContext has to be one of CG, CHG or CHH ..')
    if(!is(chrseq,"DNAString"))
        stop('chrseq has to be of class DNAString (unmasked) ..')
    if(!is.numeric(nbins))
        stop('nbins has to be of class numeric ..')
    typeD <- DNAString(seqContext)
    typeDr <- reverse(DNAString(seqContext))
    Nbins <- nbins

    chrv <- Views(chrseq, start=start(GenoRanges), end=end(GenoRanges))
    vls <- as(chrv,'DNAStringSet')
    vlsC <- Biostrings::complement(vls)
    Cpos <- startIndex(vmatchPattern(typeD, vls, fixed='subject'))
    CposC <- endIndex(vmatchPattern(typeDr, vlsC, fixed='subject'))
    for(i in 1:length(Cpos)) {
        res <- c(Cpos[[i]], CposC[[i]])
        if(!is.null(res)) Cpos[[i]] <- sort(res)
    }

                                        # restore bin structure (Nbins entry for each genomic region)
    CposList <- list()
    for(i in 1:length(Cpos))
        {
            binList <- list()
            startPos <- 1
            binsize <- round(width(GenoRanges)[i])/Nbins
            endPos <- binsize
            for(bin in 1:Nbins)
                {
                    ind <- which(Cpos[[i]] >= startPos & Cpos[[i]] <= endPos)
                    binList[[bin]] <- Cpos[[i]][ind]
                    startPos <- endPos+1
                    endPos <- endPos+binsize
                }
            if(length(binList) == 0)
                CposList[[i]] <- NA
            else
                CposList[[i]] <- binList
        }
    return(CposList)
}


getCposDensity<- function(GenoRanges, Cpos, nbins) {
    allwidths <- width(GenoRanges)
    Nbins <- nbins
    for(i in 1:length(Cpos)) {
        widths <- rep(round(allwidths[i]/Nbins), Nbins)
        if(all(is.na(Cpos[[i]])))
          Cpos[[i]] <- rep(0,nbins)
        else
          Cpos[[i]] <- sapply(Cpos[[i]], length)/widths
    }
    return(Cpos)
}

                                        # assign binmC, binC, binrC for GEcollection using Tabix based BSdata ...

profileDNAmetBin <- function(GenoRanges, Sample,
                             mcCLASS='mCG',
                             mC=1, depthThr=0, mCpv=1,
                             minCoverage=0.75, nbins=2) {
    if(!is(GenoRanges, "GRanges"))
        stop('GenoRanges has to be of class GRanges ..')
    if(!is(Sample,"BSdata"))
        stop('Sample has to be of class BSdata ..')
    if(length(which(!(mcCLASS %in% c('mCG','mCHG','mCHH')))) > 0)
        stop('mcCLASS has to be one of mCG, mCHG, and mCHH ..')
    if(!is.numeric(mC) & mC < 0 )
        stop('mC has to be of class numeric and positive..')
    if(!is.numeric(depthThr))
        stop('depthThr has to be of class numeric ..')
    if(!is.numeric(mCpv))
        stop('mCpv has to be of class numeric ..')
    if(!is.null(minCoverage) & !is.numeric(minCoverage))
        stop('minCoverage has to be either NULL or of class numeric ..')
    if(!is.numeric(nbins))
        stop('nbins has to be of class numeric ..')

    Nbins <- nbins
                                        # extracting the mC methylation level 2sec
    bsdat <- mapBSdata2GRangesBin(GenoRanges=GenoRanges, Sample= Sample,
                                  context=sub('m','',mcCLASS), mC=mC,
                                  depth=depthThr, pValue=mCpv, nbins=Nbins)
                                        # binmC
    sumFun <- function(x) {
        suppressWarnings(if(is.na(x)[[1]]) return(NA))
        sum(mcols(x)$C/(mcols(x)$C+mcols(x)$T))
    }
    mlsum <- lapply(bsdat, sapply, sumFun)
    binmC <- matrix(unlist(mlsum), length(mlsum), Nbins, byrow=T)
    unmethList <- list()
    uncov <- Sample@uncov
    uncov <- uncov[mcols(uncov)$score <= depthThr]
    seqlengths(uncov) <- NA
    seqlengths(GenoRanges) <- NA
    ### missing sequencing coverage has value NA and unmethylated has value 0
    for(bin in 1:Nbins) {
      gel <- extractBinGRanges(GenoRanges=GenoRanges, bin=bin, nbins=Nbins)
      ov <- findOverlaps(gel,uncov)
      if(length(ov) > 0)
      {
        val <- rep(0,length(GenoRanges))
        ind <- unique(queryHits(ov))
        val[ind] <- NA
        unmethList[[bin]] <- val 
      }
      else
      {
        val <- rep(0,length(GenoRanges))
        unmethList[[bin]] <- val
      }  
    }
    
    unmethList <- matrix(unlist(unmethList), Nbins, length(GenoRanges), byrow=T)
    unmethList <- t(unmethList)
    ind <- which(is.na(binmC))
    binmC[ind] <- unmethList[ind]
    
    wbp <- round(width(GenoRanges)/Nbins)
    binmC <- apply(binmC, 2, function(x) x/wbp)

                                        # binC
    Cpos <- getCpos(GenoRanges= GenoRanges,
                    seqContext= sub('m','', mcCLASS),
                    org= Sample@org, nbins=Nbins)
    CposD <- getCposDensity(GenoRanges, Cpos=Cpos, nbins=Nbins)
    binC <- matrix(unlist(CposD), length(CposD), Nbins, byrow=T)

                                        # reversing for minus strand if strand is defined
    
    if(is.null(dim(binmC)))
      binmC <- matrix(binmC, nrow=1, ncol=length(binmC), byrow=T)
    
    minusStrand <- which(as.character(strand(GenoRanges)) == '-')
    if(length(minusStrand) > 0) {
        binmC[minusStrand,] <- binmC[minusStrand, Nbins:1]
        binC[minusStrand,] <- binC[minusStrand, Nbins:1]
    }

                                        # adding relative methylation (C/mC) expressed on [0,100] range

    if(is.null(ncol(binmC)))
        binmC <- matrix(binmC, ncol=length(binmC))

    binrC <- binmC
    for(i in 1:ncol(binrC)) binrC[,i] <- 100*binmC[,i]/binC[,i]
    binrC[is.infinite(binrC)] <- NA

                                        # adding uncovered region information
    maskUncovered <- uncov
    suppressWarnings(nonCoveredInds <- findOverlaps(GenoRanges, maskUncovered))
    orgInds <- queryHits(nonCoveredInds)
    binrC[orgInds,] <- NA

                                        # cutting some decimals and specifying row/column names for the slots
    row_names <- paste(as.character(seqnames(GenoRanges)),
                       ":", start(GenoRanges),"-", end(GenoRanges), sep="")
    col_names <- c(1:Nbins)
    binmC <- signif(binmC, 3)
    colnames(binmC) <- col_names
    rownames(binmC) <- NULL
    binC <- signif(binC, 3)
    colnames(binC) <- col_names
    rownames(binC) <- NULL
    binrC <- signif(binrC, 3)
    colnames(binrC) <- col_names
    rownames(binrC) <- NULL
    binscore <- matrix(NA, nrow(binmC),
                       ncol(binmC), dimnames=list(row_names, col_names))
    rownames(binscore) <- NULL
    #rownames(GenoRanges) <- row_names
                                        # saving chr results
    Object <- new("GEcollection",
                  SummarizedExperiment(assays=list(binmC=binmC,
                                           binC=binC, binrC=binrC,
                                           binscore=binscore),
                                       rowRanges=GenoRanges))
    #rownames(Object) <- row_names
    Object
}


profileDNAmetBinParallel <- function(GenoRanges, Sample, mcCLASS='mCG',
                                     mC=1, depthThr=0, mCpv=1,
                                     minCoverage=0.75, Nproc=1, nbins=2){

    if(!is(GenoRanges, "GRanges"))
        stop('GenoRanges has to be of class GRanges ..')
    if(!is(Sample,"BSdata"))
        stop('Sample has to be of class BSdata ..')
    if(length(which(!(mcCLASS %in% c('mCG','mCHG','mCHH')))) > 0)
        stop('mcCLASS has to be one of mCG, mCHG, and mCHH ..')
    if(!is.numeric(mC) & mC < 0 )
        stop('mC has to be of class numeric and positive..')
    if(!is.numeric(depthThr))
        stop('depthThr has to be of class numeric ..')
    if(!is.numeric(mCpv))
        stop('mCpv has to be of class numeric ..')
    if(!is.null(minCoverage) & !is.numeric(minCoverage))
        stop('minCoverage has to be either NULL or of class numeric ..')
    if(!is.numeric(Nproc) & Nproc < 1)
        stop('Nproc has to be of class numeric ..')
    if(!is.numeric(nbins))
        stop('nbins has to be of class numeric ..')

    Chrs <- unique(as.character(seqnames(GenoRanges)))
    tabixChrs <- seqnamesTabix(Sample@file)
    otherChr <- which(!(as.character(seqnames(GenoRanges)) %in% tabixChrs))
    otherChr <- which(!(as.character(seqnames(GenoRanges)) %in% tabixChrs))
    if(length(otherChr) > 0) GenoRanges <- GenoRanges[-c(otherChr)]
    Chrs <- unique(as.character(seqnames(GenoRanges)))
    Nproc <- min(Nproc, length(Chrs))
    cl <- makeCluster(Nproc, 'PSOCK')
                                        # a load balanced parallel execution of the profileDNAmetBin method is run
    profileDNAmetBinChr <- function(CHR, GenoRanges,
                                    Sample, mcCLASS, mC,
                                    depthThr, mCpv,
                                    minCoverage, nbins) {
        GenoRangesChr <- GenoRanges[seqnames(GenoRanges) == CHR]
        res <- profileDNAmetBin(GenoRanges=GenoRangesChr, Sample=Sample,
                                mcCLASS=mcCLASS, mC=mC, depthThr=depthThr,
                                mCpv=mCpv, minCoverage=minCoverage, nbins=nbins)
        res
    }

    clRes <- clusterApplyLB(cl, Chrs, profileDNAmetBinChr,
                            GenoRanges=GenoRanges, Sample=Sample,
                            mcCLASS=mcCLASS, mC=mC, depthThr=depthThr,
                            mCpv=mCpv, minCoverage=minCoverage, nbins=nbins)
    chrcomb <- NULL
    chrcomb <- do.call("rbind", clRes)
    Object <- new("GEcollection", SummarizedExperiment(assays=assays(chrcomb),
                                                       rowRanges(chrcomb)))
    Object
}



                                  # function to plot gene locus visualization with methylation/omics data

plotMeth <- function(grl=NULL, colors=NULL, datatype=NULL, yLim, brmeth=NULL, mcContext="CG", annodata=NULL, 
                     transcriptDB, chr, start, end, org){
    if(!is.null(grl) & !is(grl,'list') & !is(grl,'GElist'))
        stop('grl has to be either NULL or an object of class list or GElist...')
    if(is(grl,'list'))
        {
            if(any(!(sapply(grl, class) %in% c("GRanges", 'GEcollection'))))
                stop('grl has to be a list of either GRanges or GEcollection object...')
        }
    if(!is.null(brmeth) & !is(brmeth,'list'))
      stop('brmeth has to be either NULL or of class list ...')
    if(is(brmeth,'list'))
    {
      if(any(!(sapply(brmeth, class) %in% c("BSdata"))))
        stop('grl has to be a list of BSdata object...')
    }
    if(is.null(grl) & is.null(brmeth))
      stop('both grl and brmeth cannot be NULL...')
    if(!is.null(colors) & !is.character(colors))
      stop('colors has to be either NULL or of class character ...')
    
    if(!is.null(grl))
    {
      if(is.null(names(grl)))
        stop('names of grl cannot be NULL...')
      if(is.null(datatype))
        stop('datatype cannot be NULL when grl is defined and has to be of length equal to grl...')
      if(is.character(colors))
      {
        if(length(colors) != length(grl))
          stop('length of colors has to be same as length of grl ...')
      }
      if(!is.numeric(yLim))
        stop('yLim has to be of class numeric ..')
      if(!is.null(datatype))
      {
        for(i in 1:length(datatype)) {
          dti <- datatype[i]
          if(!(dti %in% c('density', 'C','mC', 'rC','cols')))
            stop('datatype has to be an array containing
           one of: density, C, mC, rC, cols')
        }
        if(length(datatype) != length(grl) & length(grl) != length(yLim))
          stop('grl, datatype and yLim has to be of same length ..')
      }
    }
    
    if(length(which(!(mcContext %in% c('all','CG','CHG','CHH')))) > 0)
      stop('mcContext has to be one of all, CG, CHG, and CHH ..')
    if(!is.null(annodata) & !is(annodata,'GRangesList'))
      stop('annodata has to be either NULL or of class GRangesList ...')
    if(!is(transcriptDB,"TxDb") & !is.null(transcriptDB))
        stop('transcriptDB has to be either NULL or an object of class TxDb ..')
    if(!is.character(chr))
        stop('chr has to be of class character ..')
    if(!is.numeric(start))
      stop('start has to be of class numeric ..')
    if(!is.numeric(end))
        stop('end has to be of class numeric ..')
    if(!is(org, "BSgenome"))
      stop('org has to be of class BSgenome ..')
    
  
    gen <- metadata(org)$genome
    itrack <- IdeogramTrack(genome = gen, chromosome = chr)
    axisTrack <- GenomeAxisTrack()
    dTrack <- NULL
    brTrack <- NULL 
    AnnoTrack <- NULL 
    txTrack <- NULL
    
    if(!is.null(grl))
    {
      matlist <- list()
      dTrack <- list()
      for (i in 1:length(grl))
      {
        grl_trackname <- names(grl)
        if(datatype[i] == 'mC') {
          refgr <- rowRanges(grl[[i]])
          matlist[[i]] <- t(apply(binmC(grl[[i]]),1,mean))
        }
        if(datatype[i] == 'C') {
          refgr <- rowRanges(grl[[i]])
          matlist[[i]] <- t(apply(binC(grl[[i]]),1,mean))
        }
        if(datatype[i] == 'rC') {
          refgr <- rowRanges(grl[[i]])
          matlist[[i]] <- t(apply(binrC(grl[[i]]),1,mean))
        }
        if(datatype[i] == 'density') {
          refgr <- rowRanges(grl[[i]])
          matlist[[i]] <- t(apply(binscore(grl[[i]]),1,mean))
        }
        if(datatype[i] == 'cols') {
          refgr <- grl[[i]]
          matlist[[i]] <- t(as.matrix(mcols(grl[[i]])[1]))
        }
        if(is.null(colors))
          dTrack[[i]] <- DataTrack(range=refgr, data=matlist[[i]] , name=grl_trackname[i], chromosome=chr,
                                   fill="darkgreen", ylim=c(0, yLim[i]))
        else
          dTrack[[i]] <- DataTrack(range=refgr, data=matlist[[i]] , name=grl_trackname[i], chromosome=chr,
                                   fill=colors[i], ylim=c(0, yLim[i]))
      }
    }
    
    brmeth_gr <- GRanges(chr,IRanges(start,end))
    if(abs(start-end) < 50){
      strack <- SequenceTrack(org)
      anntrack <- list(itrack, axisTrack, strack)
    }
    else
      anntrack <- list(itrack, axisTrack)

    if(!is.null(grl))
      plotype_length <- length(grl)
    else
      plotype_length <- 0
    if(!is.null(brmeth))
    {
      brTrack <- list()
      bsdat <- NULL
      brlist <- list()
      if(is.null(names(brmeth)))
        stop('names of brmeth cannot be NULL...')
      brmeth_trackname <- names(brmeth)
      for (i in 1:length(brmeth))
      {
        bsdat[i] <- unlist(mapBSdata2GRanges(GenoRanges=brmeth_gr, Sample= brmeth[[i]],
                                      context=mcContext))
        if(is.na(bsdat[i]))
          stop('This genomic range does not have any base resolution methylation data for the given sequence context..')
        mc <- mcols(bsdat[[i]])$C/(mcols(bsdat[[i]])$C+ mcols(bsdat[[i]])$T)
        mc <- as.matrix(mc)
        temp_gr <- bsdat[[i]]
        strand(temp_gr) <- "*"
        brTrack[[i]] <- DataTrack(range=temp_gr, data=t(mc) , name=brmeth_trackname[i], chromosome=chr,
                                 col.histogram="black", ylim=c(0, 1))
      }
      plotype_length <- plotype_length+length(brmeth)
    }

    plottype <- rep("histogram", plotype_length)
#### adding annotation track

    if(!is.null(annodata))
    {
      AnnoTrack <- list()
      if(is.null(names(annodata)))
        stop('names of annodata cannot be NULL...')
      anno_trackname <- names(annodata)
      col <- rainbow(length(annodata))
      for (i in 1:length(annodata))
      {
        AnnoTrack[[i]] <- AnnotationTrack(annodata[[i]], name=anno_trackname[i], fill=col[i])
      }
    }

    if(!is.null(transcriptDB))
     {
    	txdb <- transcriptDB
    	txTrack <- GeneRegionTrack(txdb, chromosome=chr, name="Transcripts", showId=TRUE,
    	                           geneSymbol=TRUE, background.panel = "#FFFEDB", background.title = "brown")
    }
    
    combtrack <- c(anntrack, dTrack, brTrack, AnnoTrack, txTrack)
    plotTracks(combtrack, type=plottype, chromosome=chr, from=start, to=end,
               reverseStrand = FALSE, background.panel = "#FFFEDB", background.title = "brown", col="black")
}

                                        # subset
setMethod('[[', 'GElist', function(x, i, j = "missing"){
    GEl = x@Objlist[[i]]
    GEl
})

setMethod('[[<-', 'GElist', function(x, i, j = "missing", value) {
    x@Objlist[[i]] = value
    x
})

setMethod('[', 'GElist', function(x, inds, i='missing', j='missing',
                                  drop ="missing") {
    x@Objlist = x@Objlist[inds]
    x
})

                                        # length
setMethod('length', 'GElist', function(x) {
    length(x@Objlist)
})

setMethod("$", "GElist", function(x, name){
    x@Objlist[[name]]
})

setClass(Class = 'BSdata',
         slots = c(file = 'character',
             uncov = 'GRanges', org = 'BSgenome'))
setValidity("BSdata", function(object) {
    tabixRef <- TabixFile(object@file, yieldSize=1000L)
    tbdata <- scanTabix(tabixRef)
    tbdata <- unlist(tbdata)
    tbdata <- tabixdata2GR(tbdata)
    chrs <- seqnames(object@org)
    if(length(which( !(as.character(seqnames(tbdata)) %in% chrs))) > 0)
        return("the 1st column of the BSdata has to contain
chr assignments in the form chr1, chr2, ...
included in the org reference sequence")
    if(length(which( !(mcols(tbdata)$Context %in% c('CG','CHG', 'CHH')))) > 0)
        return("the 4th column of the BSdata
         has to contain one of CG, CHG or CHH ..")
    if(!is.numeric(mcols(tbdata)$C) | length(which(mcols(tbdata)$C < 1)) > 0)
        return("the 5th column of the BSdata
         has to contain only positive integers >=1 ..")
    if(!is.numeric(mcols(tbdata)$T) | length(which(mcols(tbdata)$T < 0)) > 0)
        return("the 6th column of the BSdata
         has to contain only positive integers ..")
    if(!is.numeric(mcols(tbdata)$Significance) |
       length(which(mcols(tbdata)$Significance < 0)) > 0)
        return("the 7th column of the BSdata
         has to contain only positive integers ..")
    NULL
})



setClass(Class = 'BSdataSet', slots = c(Objlist='list', names='character',
                                  group='character', org='BSgenome'))
setValidity("BSdataSet", function(object) {
    if(length(object@Objlist) != length(object@group))
        return("length of group has to be equal to number of objects")
    if(length(object@Objlist) == 1)
        return("more then one BSdata object has to be provided")
    if(!is(object@names,"character"))
        return("names has to be of class character")
    if(!is(object@group,"character"))
        return("group has to be of class character")
    if(length(object@Objlist)==2)
    {
      if( any( !object@group %in% c("C","E")))
        return("if only two groups they can only be 'C' or 'E'")
    }
    for(i in 1:length(object@Objlist))
        if(!is(object@Objlist[[i]],"BSdata"))
            return("the object has to be of class BSdata")
    for(i in 1:length(object@Objlist))
        {
            object@Objlist[[i]]@file <- (object@Objlist[[i]])@file
            object@Objlist[[i]]@uncov <- (object@Objlist[[i]])@uncov
        }
    NULL
})


setClass(Class = 'GEcollection', contains = "RangedSummarizedExperiment",
         prototype = prototype(SummarizedExperiment(assays = SimpleList(binmC = matrix(0, 0, 0),
                                                        binC = matrix(0, 0, 0),
                                                        binrC = matrix(0, 0, 0),
                                                        binscore = matrix(0, 0, 0)))))
setValidity("GEcollection", function(object) {
    requiredAssays <- c("binmC", "binC", "binrC", "binscore")
    if ( !identical(requiredAssays, c(names(assays(object)))))
        return("assays slots have to in the order: binmC, binC, binrC, binscore")
    if ( all(!is.na(assays(object)[["binmC"]]) ,
        min(assays(object)[["binmC"]], na.rm = TRUE) < 0))
        return("The binmC values have to either NA or positive")
    if ( all(!is.na(assays(object)[["binC"]]) ,
        min(assays(object)[["binC"]], na.rm = TRUE) < 0))
        return("The binC values have to either NA or positive")
    if (all(!is.na(assays(object)[["binrC"]]) ,
        min(assays(object)[["binrC"]], na.rm = TRUE) < 0 ,
        max(assays(object)[["binrC"]], na.rm = TRUE) > 1))
        return("The binrC values have to either NA or between 0 and 1")
    if (all(!is.na(assays(object)[["binscore"]]) ,
        min(assays(object)[["binscore"]], na.rm = TRUE) < 0))
        return("The binscore values have to either NA or positive")
    NULL
})


setClass(Class = 'GElist', slots = c(Objlist="list",
                               names="character"))
setValidity("GElist", function(object) {
    for(i in 1:length(object@Objlist))
        if(!is(object@Objlist[[i]],"GEcollection"))
            return("object has to be of class GEcollection")
    NULL
})

# show method
setMethod('show', 'BSdata', function(object) {
    message("S4 Object of class BSdata")
    message()
    message("TABIX indexed file for this BSdata:")
    message(object@file)
    message()
    message('The first lines of the uncovered regions of this BSdata:')
    print(head(object@uncov))
    message("Associated organism genome:")
    message(organism(object@org))
    message()

                                        # requires Rsamtools TabixFile function...
    tabixRef <- TabixFile(object@file, yieldSize=1000L)
    message('Chromosomes available:')
    print(seqnamesTabix(tabixRef))
    tbdata <- scanTabix(tabixRef)
    tbdata <- unlist(tbdata)
                                        # tabixdata2GR in Allfunctions.R
    tbdata <- tabixdata2GR(tbdata)
    message('The first lines of the data:')
    print(head(tbdata))
})




setGeneric('mCsmoothing', function(Object, refgr, Scorefun='sum', Nbins=20,
                                   Context='CG', plot=TRUE)
           standardGeneric('mCsmoothing'))
setMethod('mCsmoothing','BSdata', function(Object, refgr, Scorefun='sum',
                                           Nbins=20, Context='CG', plot=TRUE) {
    chrs <- seqnames(Object@org)
    chr <- unique(as.character(seqnames(refgr)))
    if(any(!chr %in% chrs))
        stop('This is not a valid chromosome .. ')
    if(!is(refgr, "GRanges"))
        stop('refgr has to be of class GRanges ..')
    if(Scorefun != 'sum' && Scorefun != 'mean')
        stop('Scorefun has to be either sum or mean .. ')
    if(length(which(!(Context %in% c('all','CG','CHG','CHH')))) > 0)
        stop('Context has to be either all or a combination of CG, CHG, and CHH ..')
    if(!is.logical(plot))
        stop('plot has to be of class logical ..')
    if(!is.numeric(Nbins))
        stop('Nbins has to be of class numeric')
    if(!(Nbins >5))
      stop('Nbins has to be of greater than 5')

                                        # a generic function to determing data binning
                                        # through the binning C function included in the package
    chrdensity <- function(GenoRanges, pos, score, scorefun, nbins) {
        bins <- NULL
        binsize <- width(GenoRanges)/nbins
        for (bin in 1:(nbins+1))
          bins[bin] <- round(start(GenoRanges) + (bin-1)*binsize)
        if(scorefun == 'sum') res <- .C(.binning,score=as.double(score),
               pos=as.double(pos), as.integer(length(pos)),
               bins=bins, as.integer(length(bins)),
               binout=as.double(rep(0,length(bins))), doavg=as.integer(0),
               PACKAGE='methylPipe')
        if(scorefun == 'mean') res <- .C(.binning,score=as.double(score),
               pos=as.double(pos), as.integer(length(pos)),
               bins=bins, as.integer(length(bins)),
               binout=as.double(rep(0,length(bins))), doavg=as.integer(1),
               PACKAGE='methylPipe')
        return(res$binout)
    }
    mcdata <- mapBSdata2GRanges(GenoRanges=refgr, Sample=Object,
                                context=Context, mC=0, depth=0, pValue=1)
    ind <- which(is.na(mcdata)==TRUE)
    if(length(ind)!=0)
    {
      mcdata <- mcdata[-c(ind)]
      refgr <- refgr[-c(ind)]
    }

                                        # using the methylation level (proportion of C/(C+T) reads for a given position)
    Score <- sapply(mcdata, function(x) mcols(x)$C/(mcols(x)$C+mcols(x)$T))
    if(!is(Score, "list"))
        Score <- list(Score)

    mCdChr <- NULL
    Pos <- sapply(mcdata, function(x) start(x))
    if(!is(Pos, "list"))
        Pos <- list(Pos)

    for (i in 1:length(mcdata))
        {
        temp <- chrdensity(GenoRanges=refgr[i], pos=c(Pos[[i]]),
                           score=c(Score[[i]]), scorefun=Scorefun,
                           nbins=Nbins)
        mCdChr[[i]] <- temp[-c(length(temp))]
    }

    mCdChr <- matrix(unlist(mCdChr), ncol = Nbins, byrow = TRUE)
    mCdChr <- apply(mCdChr, 2, mean)

                                        # data are smoothed
    Cs <- smooth.spline(x=1:length(mCdChr),
                        y=mCdChr, spar=0.5, keep.data=FALSE)
    totalwidth <- width(refgr)
    bin <- round(Nbins*.1)
    binsize <- totalwidth/bin
    bins <- seq(start(refgr),totalwidth,binsize)
    if(plot)
    {
      plot(x=Cs$x, y=100*Cs$y/max(Cs$y), axes=FALSE,xlab=NA,
           ylab=NA, type='l', lwd=2, ylim=c(0,100), col="darkgreen",
           main="Smoothed methylation levels")
      box()
      axis(side = 2)
      axis(side = 1, at=c(seq(1,Nbins,round(Nbins/bin)),Nbins),
           labels=c(bins,end(refgr)))
      mtext(side = 1, "Genomic co-ordinates", line = 3)
      mtext(side = 2, "Methylation Level (mC/total reads)", line = 3)
  }

    return(list(pos=c(1:Nbins),
                score=mCdChr, smoothed=Cs))
})


setGeneric('findPMDs', function(Object, Nproc=10, Chrs=NULL)
           standardGeneric('findPMDs'))
setMethod('findPMDs', 'BSdata', function(Object, Nproc=10, Chrs=NULL){
    if(!is.null(Chrs) && !is.character(Chrs))
        stop("Chrs has to be either NULL or class character")
    ind <- Chrs %in% seqnamesTabix(Object@file)
    if(any(ind==FALSE))
        stop("Chrs not found in the sample...")
    if(is.null(Chrs))
        Chrs <- seqnamesTabix(Object@file)

    PMDchr <- function(Ind, object, Blocks, org)
        {
            refgr <- GRanges(Blocks$chr[Ind],IRanges(Blocks$start[Ind],Blocks$end[Ind]))
            meth.gr <- mapBSdata2GRanges(GenoRanges= refgr, Sample= object, context= "CG")[[1]]
            mcols(meth.gr) <- mcols(meth.gr)[3:2]
            mcols(meth.gr)$T <- mcols(meth.gr)$T+mcols(meth.gr)$C
            chr <- Blocks[Ind,1]
            chrL <- seqlengths(org)[chr]
            options(menu.graphics=FALSE)
            PMDsegments.gr <- segmentPMDs(m=meth.gr, chr.sel=chr, seqLengths=chrL, num.cores=1)
        }

    blocks <- splitChrs(chrs=Chrs, org=Object@org)
    cl <- makeCluster(Nproc, 'PSOCK')
    clusterEvalQ(cl, library(MethylSeekR))
    clRes <- clusterApplyLB(cl, 1:nrow(blocks), PMDchr, object=Object,
                            Blocks=blocks, org=Object@org)
    PMDscomb <- GRangesList(clRes)
    return(PMDscomb)
})

# show method
setMethod('show', 'BSdataSet', function(object) {
    message("S4 Object of class BSdataSet")
    message()
    message("BSdata objects contained:")
    print(names(object))
    message()
    message("Groups of objects:")
    print(object@group)
    message()
    message("Associated organism genome:")
    message(organism(object@org))
    message()
})

                                        # subset
setMethod('[[', 'BSdataSet', function(x, i, j = "missing") {
    bsdata <- new('BSdata', file=x@Objlist[[i]]@file,
                  uncov=x@Objlist[[i]]@uncov, org=x@org)
    bsdata
})

setMethod('[[<-', 'BSdataSet', function(x, i, j = "missing", value) {
    x@Objlist[[i]]@file <- value@file
    x@Objlist[[i]]@uncov <- value@uncov
    x
})

setMethod('[','BSdataSet', function(x, inds, i= 'missing', j= 'missing',
                                    drop = "missing") {
    x@Objlist = x@Objlist[inds]
    x
})

                                        # length
setMethod('length', 'BSdataSet', function(x) {
    length(x@Objlist)
})


setMethod("$", "BSdataSet", function(x, name){
    x@Objlist[[name]]
})


                                        # get DMR GRanges
setGeneric('findDMR',
           function(object, Nproc=NULL, ROI=NULL,
                    pmdGRanges=NULL, MCClass='mCG',
                    dmrSize=10, dmrBp=1000, binsize=0,
                    eprop=0, coverage=1, Pvalue=NULL, SNPs=NULL)
           standardGeneric('findDMR'))
setMethod('findDMR', 'BSdataSet', function(object, Nproc=NULL, ROI=NULL,
                                           pmdGRanges=NULL, MCClass='mCG',
                                           dmrSize=10, dmrBp=1000,
                                           binsize=0, eprop=0, coverage=1, Pvalue=NULL, SNPs=NULL) {
    if(!is.numeric(Nproc) && !is.null(Nproc))
        stop('Nproc has to be of class numeric or NULL..')
    if(!is.null(pmdGRanges) && !is(pmdGRanges, "GRanges"))
        stop('pmdGRanges has to be either NULL or an object of class GRanges ..')
    if(!is.null(ROI) && !is(ROI, "GRanges"))
        stop('ROI has to be either NULL or an object of class GRanges ..')
    if(!(MCClass %in% c('mCG','mCHG','mCHH', 'all')))
        stop('MCClass has to be one of mCG, mCHG, mCHH or all')
    if(!is.numeric(dmrSize))
        stop('dmrSize has to be an object of class numeric ..')
    if(dmrSize < 5)
        stop('dmrSize has to be atleast 5 ..')
    if(!is.numeric(dmrBp))
        stop('dmrBp has to be an object of class numeric ..')
    if(!is.numeric(binsize))
        stop('binsize has to be an object of class numeric ..')
    if(!is.numeric(eprop))
        stop('eprop has to be an object of class numeric ..')
    if((eprop < 0) || (eprop > 1))
        stop('eprop has to be from 0 to 1 ..')
    if(!is.null(SNPs) && !is(SNPs,"GRanges"))
        stop('SNPs has to be either NULL or an object of class GRanges ..')
    if(!is.null(Pvalue) && !is.numeric(Pvalue))
        stop('Pvalue has to be either NULL or an object of class numeric ..')
    if(!is.numeric(coverage))
        stop('coverage has to be an object of class numeric ..')

                                        # parallelize tasks based on each chromosome

    DMRchr <- function(Ind, Blocks=blocks, PMDs=pmdGRanges,
                       samples=object, MCClass=MCClass,
                       DmrSize=dmrSize, DmrBp=dmrBp,
                       Binsize=binsize, Eprop=eprop, Coverage=coverage, pValue=Pvalue, SNP=SNPs) {
                                        # Ind is the requested region of this call of the DMRchr function
        Chr <- as.character(Blocks[Ind,1])
        start <- round(Blocks[Ind,2])
        refgr <- GRanges(seqnames = Chr, ranges = IRanges(Blocks[Ind,2], end = Blocks[Ind,3]))
        minC <- DmrSize

                                        # mC calls are retrieved for each sample
        resList <- list()
        Cposind <- NULL

        for(i in 1:length(samples)) {
            message('retreiving methylation data from sample.. ')
            resList[[i]] <- mapBSdata2GRanges(GenoRanges= refgr, Sample= samples[[i]], depth=0,
                                              context= sub('m', '', MCClass))[[1]]
            if(!is(resList[[i]],"GRanges")) return(NULL)
            Cposind <- c(Cposind, start(resList[[i]]))
        }


        if(Binsize > 0){
            message('getting mc data .. ')
            Cposind <- NULL
            Cposind <- unlist(getCpos(refgr, seqContext = sub('m', '', MCClass), nbins = 1,
                                      org = samples@org))
            if(length(Cposind)==0) return(NULL)
            Cposind <- round(unique(Cposind))
            Cposind <- sort(Cposind)
            Cposind <- (Cposind+start-1)
        }
        else
            {
                Cposind <- round(unique(Cposind))
                Cposind <- sort(Cposind)
    }


        if(Coverage > 1)
            {
                covrm <- NULL
                for(i in 1:length(samples)) {
                    message('removing minimum coverage cutoff cytosines.. ')
                    inds <- which((mcols(resList[[i]])$C+mcols(resList[[i]])$T) < Coverage)
                    covrm <- c(covrm, start(resList[[i]])[inds])
                }
                torm <- which((Cposind %in% covrm)==TRUE)
                Cposind <- Cposind[-c(torm)]
            }
    
        if(length(Cposind)==0) return(NULL)
        message('building ratioGR .. ')
        ratioMat <- matrix(0, length(Cposind), length(samples))
        ratioGR <- GRanges(Rle(Chr), IRanges(Cposind, Cposind), elementmetaData=ratioMat)
        rm(ratioMat)
        names(mcols(ratioGR)) <- samples@group

                                        # removing SNPs if provided
        if(!is.null(SNP))
            {
                message("removing SNPs")
                ov <- findOverlaps(ratioGR, SNP)
                if(length(ov)>0) ratioGR <- ratioGR[-unique(queryHits(ov))]
            }

                                        # fixing unmethylated C, fill ratioGR

        for(i in 1:length(samples)) {
            message('fixing unmethylated C .. ')
                                        # removing cytosines positions not covered by sequencing
            uncov <- samples[[i]]@uncov
            uncov <- uncov[seqnames(uncov) == Chr]
            uncov <- uncov[mcols(uncov)$score < Coverage]
            ov <- findOverlaps(ratioGR, uncov)
            if(length(ov)>0) ratioGR <- ratioGR[-unique(queryHits(ov))]
            if(length(ratioGR)== 0) return(NULL)

            message('filling ratioGR .. ')
            ind <- findOverlaps(resList[[i]], ratioGR)
            mc <- mcols(resList[[i]])$C/(mcols(resList[[i]])$C+ mcols(resList[[i]])$T)
            mcols(ratioGR)[,i][subjectHits(ind)] <- round(mc[queryHits(ind)],3)

            if(!is.null(pValue))
                {
                    message('keeping only those mC less than Pvalue threshold..')
                    pV <- -10*log10(pValue)
                    ind <- which(mcols(resList[[i]])$Significance < pV)
                                        # only if some mC crosses pvalue threshold those are removed from ratioGR
                    if(length(ind) > 0)
                        {
                            ov <- findOverlaps(ratioGR, resList[[i]][ind])
                            if(length(ov)>0) ratioGR <- ratioGR[-unique(queryHits(ov))]
                        }
                }

        }
        rm(resList)

                                        # if PMD are passed, DMR are not searched within them

        if(!is.null(PMDs))
            {
                message('filtering PMDs out ..')
                genoranges <- PMDs[seqnames(PMDs) == Chr]
                if(length(genoranges)!=0)
                    {
                        ov <- findOverlaps(ratioGR, genoranges)
                        if(length(ov)>0) ratioGR <- ratioGR[-unique(queryHits(ov))]
                    }
            }

        Cposind <- as.numeric(start(ratioGR))
                                        # smoothing ratioMat (useful for nonCG in human for example ..)
        if(Binsize > 0){
            message('applying smoothing for nonCG .. ')
            smbins <- seq(min(Cposind)-1, max(Cposind), Binsize)
            if(smbins[length(smbins)] != max(Cposind))
                smbins <- c(smbins, max(Cposind))
            ncl <- length(mcols(ratioGR))
            smMat <- matrix(NA, length(smbins)-1, ncl)
                                        # determinig the average met level within each bin
            for(icol in 1:ncl) {
                ratios <- unlist(as.data.frame(mcols(ratioGR[,icol])))
                                        # -100 identify NA in C code ..
                ratios[is.na(ratios)] <- -100
                res <- .C(.binning, score= as.double(ratios),
                          pos= as.double(Cposind),
                          poslength=as.integer(length(Cposind)),
                          binvec= smbins, binlength=as.integer(length(smbins)),
                                        # binout contains the bin avg
                          binout= as.double(rep(-100, length(smbins)-1)),
                          doavg= as.integer(1), PACKAGE='methylPipe')$binout
                res[res == (-100)] <- NA
                smMat[,icol] <- res
            }
                                        # ratioGR is replaced by the smoothed matrix
            Cposind <- smbins[-length(smbins)]
            allNAinds <- which(apply(smMat, 1, function(x) all(is.na(x))))
                                        # all NA rows are discarded
            if(length(allNAinds) > 0) {
                smMat <- smMat[-allNAinds,]
                Cposind <- Cposind[-allNAinds]
            }
            ratioGR <- GRanges(Rle(Chr), IRanges(Cposind,Cposind), elementmetaData=smMat)
            rm(smMat)
            names(mcols(ratioGR)) <- samples@group
            minC <- 6
        }
                                        #ratioMat <- as.data.frame(ratioMat)
        maxR <- length(ratioGR)
                                        # Eprop can be used to check only those mC showing
                                        # the highest empirical differential methylation between
                                        # samples to save time
        if(Eprop > 0) {
            mat <- as.data.frame(mcols(ratioGR))
            maxs <- apply(mat, 1, max, na.rm=T)
            mins <- apply(mat, 1, min, na.rm=T)
                                        # the difference between the min and the max met level for a
                                        # given mC over all the samples is used to determine the
                                        # empirical differential methylation
            diffs <- maxs-mins
            diffInds <- which(diffs >= Eprop)
            if(length(diffInds) == 0) return(NA)
            rm(mat)
        }
                                        # else all the mC are considered
        else diffInds <- 1:maxR

        NAvec=rep(NA, length(diffInds))
        dmrDf <- data.frame(chr=rep(Chr, length(diffInds)),
                            start=NAvec, end=NAvec, pValue=NAvec,
                            MethDiff_Perc=NAvec, log2Enrichment=NAvec, stringsAsFactors=FALSE)
        counter <- 0
        oldPos <- min(Cposind)-DmrBp
        message('looking for DMRs .. ')
        for(i in 1:length(diffInds)) {
            counter <- counter+1
            if(counter/10000 == trunc(counter/10000)) message(paste(counter, '', sep=''))
            ind <- diffInds[i]
            if(as.logical((Cposind[ind]- oldPos) < DmrBp/2)) next
                                        # looking from the current position ind till ind + dmrSize
                                        # (the number of mC in each evaluated block)
            indNext <- ind+DmrSize-1
                                        #if(as.logical((Cposind[indNext]- oldPos) < (DmrBp/2))) next
                                        # checking if over the considered genomic region
            if(indNext > maxR) break
                                        # checking if the distance between the end and the
                                        # begining of the block is within DmrBp
            if((Cposind[indNext]-Cposind[ind]) < DmrBp) {
                df <- as.data.frame(mcols(ratioGR)[ind:indNext,])
                                        # filtering the df based on having some data > 0 there ..
                df <- df[rowSums(df,na.rm=TRUE) > 0,]
                minN <- max(5, round(0.8*minC)) # minimum number of available data required
                if(nrow(df) < minN) next
                cs <- apply(df, 2, function(x) length(which(x > 0)))
                                        # at least one sample with at least minN positions with data > 0
                if(max(cs, na.rm=T) < minN) next
                else {
                                        # non parametric kruskall-wallis test for multi-sample comparison
                    if(length(samples) > 2) {
                        colinds <- which(apply(df, 2, function(x) !all(is.na(x))))
                                        # checking that at least 2 samples remain
                        if(length(colinds) == 1) Pv=NA
                                        # determining Pvalue
                        else Pv <- kruskal.test(df[,colinds])$p.value
                        groups <- unique(names(mcols(ratioGR)))
                        if(any( !groups %in% c("C","E")))
                            {
                                dmrDf$MethDiff_Perc[i] <- NA
                                dmrDf$log2Enrichment[i] <- NA
                            }
                        else
                            {
                                means <- colMeans(df, na.rm=T)
                                means <- t(as.matrix(means))
                                colnames(means) <- names(mcols(ratioGR))
                                ind_C <- which(colnames(means)=="C")
                                ind_E <- which(colnames(means)=="E")
                                        # the methylation difference is determined
                                Methdiff <- (mean(means[ind_E])-mean(means[ind_C]))*100
                                dmrDf$MethDiff_Perc[i] <- round(Methdiff, 3)
                                log2Enrichment <- log2(mean(means[ind_E]) / mean(means[ind_C]))
                                dmrDf$log2Enrichment[i] <- round(log2Enrichment,3)
                            }
                    }
                    else {
                                        # non parametric wilcoxon.test for 2 sample comparison
                        if(any(apply(df, 2,function(x) all(is.na(x))))) Pv <- NA
                        else {
                            noNArows <- which(apply(df,1,
                                                    function(x) length(which(is.na(x))))==0)
                            if(length(noNArows) < minN)  Pv <- NA
                            else
                                {
                                    Pv <- wilcox.test(df$C, df$E,alternative='two',
                                                      paired=TRUE, exact=FALSE)$p.value
                                }
                            Methdiff <- (mean(df$E, na.rm=T)-mean(df$C, na.rm=T))*100
                            dmrDf$MethDiff_Perc[i] <- round(Methdiff, 3)
                            log2Enrichment <- log2(mean(df$E, na.rm=TRUE) / mean(df$C, na.rm=TRUE))
                            dmrDf$log2Enrichment[i] <- round(log2Enrichment,3)
                        }
                    }
                    dmrDf$start[i] <- Cposind[ind]
                    dmrDf$end[i] <- Cposind[indNext]+Binsize
                    dmrDf$pValue[i] <- round(Pv,3)
                }
                oldPos <- Cposind[ind]
            }
        }
        rm(ratioGR)
        NAinds <- which(is.na(dmrDf$start))
        if(length(NAinds)>0) dmrDf <- dmrDf[-NAinds,]
        if(nrow(dmrDf)==0) dmrDf <- NA
        return(dmrDf)
    }

    Chrs <- list()
    for (i in 1:length(object))
        {
            tabixRef <- TabixFile(object[[i]]@file)
            Chrs[[i]] <- as.character(seqnamesTabix(tabixRef))
        }
    Chrs <- unique(unlist(Chrs))

    if(!is.null(ROI))
        {
            blocks <- as.data.frame(ROI)
            blocks <- blocks[,-c(4:5)]
        }
    else
        blocks <- splitChrs(chrs=Chrs, org=object@org)

    if(is.numeric(Nproc))
    {
      cl <- makeCluster(Nproc, type='PSOCK',outfile='clusterlog.txt')
      clRes <- clusterApplyLB(cl, 1:nrow(blocks),
                              DMRchr, Blocks=blocks, PMDs=pmdGRanges,
                              samples=object, MCClass=MCClass,
                              DmrSize=dmrSize, DmrBp=dmrBp,
                              Binsize=binsize, Eprop=eprop, Coverage=coverage, pValue=Pvalue, SNP=SNPs)
      stopCluster(cl)
    }
    else
    {
      clRes <- lapply(1:nrow(blocks),DMRchr, Blocks=blocks, PMDs=pmdGRanges,
                              samples=object, MCClass=MCClass,DmrSize=dmrSize, DmrBp=dmrBp,
                              Binsize=binsize, Eprop=eprop, Coverage=coverage, pValue=Pvalue, SNP=SNPs)
    }
        DmrDf <- NULL
    for(clind in 1:length(clRes)) {
        if(is.null(clRes[[clind]])) next
        if(is.null(nrow(clRes[[clind]]))) next
        DmrDf <- rbind(DmrDf, clRes[[clind]])
    }
    if(is.null(DmrDf)) return(NULL)
    NAinds <- which(is.na(DmrDf$pValue))
    if(length(NAinds) > 0) DmrDf <- DmrDf[-NAinds,]
    DmrGR <- GRanges(DmrDf[,1], IRanges(DmrDf[,2], DmrDf[,3]), pValue= DmrDf[,4],
                     MethDiff_Perc= DmrDf[,5], log2Enrichment= DmrDf[,6])
    rm(DmrDf)
    DmrGR <- sort(DmrGR)
})


setGeneric('methstats',
           function(object, chrom, mcClass='mCG', minC=1, coverage=1, pval=1, Nproc=1)
             standardGeneric('methstats'))
setMethod('methstats', 'BSdataSet', function(object, chrom, mcClass='mCG', minC=1, 
                                             coverage=1, pval=1, Nproc=1) {
  if(!is.null(chrom) && !is.character(chrom))
    stop('chrom has to be either NULL or an object of class character ..')
  if(!(mcClass %in% c('mCG','mCHG','mCHH', 'all')))
    stop('mcClass has to be one of mCG, mCHG, mCHH or all..')
  if(!is.numeric(minC) && minC < 0 )
    stop('minC has to be of class numeric and positive..')
  if(!is.numeric(coverage))
    stop('coverage has to be of class numeric ..')
  if(!is.numeric(pval))
    stop('pval has to be of class numeric ..')
  if(pval > 1)
    stop('pval has to be lower than 1 ..')
  if(!is.numeric(Nproc))
    stop('Nproc has to be of class numeric ..')
  
  
  # parallelize tasks based on each chromosome
  Methchr <- function(Ind, Blocks, samples, mcContext, mCs, cov, Pval)
  {
    resList <- list()
    Cposind <- NULL
    Chr <- as.character(Blocks[Ind,1])
    gr <- GRanges(seqnames = Chr, ranges = IRanges(Blocks[Ind,2], end = Blocks[Ind,3]))
    
    for(j in 1:length(samples)) {
      message('retreiving methylation data from sample.. ')
      resList[[j]] <- mapBSdata2GRanges(GenoRanges= gr, Sample= samples[[j]], depth=cov,
                                        context= sub('m', '', mcContext), mC=mCs, pValue=Pval)[[1]]
      if(!is(resList[[j]],"GRanges")) return(NULL)
      Cposind <- c(Cposind, start(resList[[j]]))    
    }
    
    Cposind <- round(unique(Cposind))
    Cposind <- sort(Cposind)
    
    message('building ratioGR .. ')
    ratioMat <- matrix(0, length(Cposind), length(samples))
    ratioGR <- GRanges(Rle(Chr), IRanges(Cposind, Cposind), elementmetaData=ratioMat)
    rm(ratioMat)
    names(mcols(ratioGR)) <- names(samples)
    
    for(i in 1:length(samples)) {
      message('fixing unmethylated C .. ')
      # removing cytosines positions not covered by sequencing
      uncov <- samples[[i]]@uncov
      uncov <- uncov[seqnames(uncov) == Chr]
      uncov <- uncov[mcols(uncov)$score < cov]
      ov <- findOverlaps(ratioGR, uncov)
      if(length(ov)>0) ratioGR <- ratioGR[-unique(queryHits(ov))]
      if(length(ratioGR)== 0) return(NULL)
      
      message('filling ratioGR .. ')
      ind <- findOverlaps(resList[[i]], ratioGR)
      mc <- mcols(resList[[i]])$C/(mcols(resList[[i]])$C+ mcols(resList[[i]])$T)
      mcols(ratioGR)[,i][subjectHits(ind)] <- round(mc[queryHits(ind)],3)    
    }
    ratioGR
  }
  
  Chrs <- list()
  for (i in 1:length(object))
  {
    tabixRef <- TabixFile(object[[i]]@file)
    Chrs[[i]] <- as.character(seqnamesTabix(tabixRef))
  }
  Chrs <- unique(unlist(Chrs))
  
  if(!is.null(chrom))
  {
    if(!chrom %in% Chrs) 
    {
      stop('chromosome not available in samples .. ')
    }
    blocks <- splitChrs(chrs=Chrs, org=object@org)
    ind <- which(blocks[,1]==chrom)
    blocks <- blocks[ind,]
  }
  else
    blocks <- splitChrs(chrs=Chrs, org=object@org)
  
  cl <- makeCluster(Nproc, type='PSOCK',outfile='clusterlog.txt')
  clRes <- clusterApplyLB(cl, 1:nrow(blocks),
                          Methchr, Blocks=blocks, samples=object, 
                          mcContext=mcClass, mCs=minC, cov=coverage, Pval=pval)
  stopCluster(cl)
  ind <- which(is.na(clRes)==TRUE)
  if(length(ind)!=0)
    clRes <- clRes[-c(ind)]
  if(length(clRes)==1)
    clRes <- clRes[[1]]
  else
  {
    clRes_comb <- GRangesList(clRes)
    clRes <- unlist(clRes_comb)
    rm(clRes_comb)
  }
  mc_table <- as.data.frame(mcols(clRes))
  rm(clRes)
  
  
  ########## statistics and plots ##########
  
  ######### descriptive stats ##########
  statistics_results <- list()
  statistics_results[[1]] <- summary(mc_table)
  statistics_results[[2]] <- cor(mc_table)
  names(statistics_results) <- c("descriptive_stats","correlation_mat")
  
  ##### correlation plots #########
  
  panel.cor <- function(x, y, digits=2, cex.cor)
  {
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(0, 1, 0, 1))
    r <- abs(cor(x, y))
    txt <- format(c(r, 0.123456789), digits=digits)[1]
    test <- cor.test(x,y)
    Signif <- ifelse(round(test$p.value,3)<0.01,"p<0.01",paste("p=",round(test$p.value,3)))  
    text(0.5, 0.25, paste("r=",txt))
    text(.5, .75, Signif)
  }
  
  panel.smooth<-function (x, y, col = "orange", bg = NA, pch = 46, 
                          cex = 1.5, col.smooth = "red", span = 2/3, iter = 3, ...) 
  {
    points(x, y, pch = pch, col = col, bg = bg, cex = cex)
    ok <- is.finite(x) & is.finite(y)
    if (any(ok)) 
      lines(stats::lowess(x[ok], y[ok], f = span, iter = iter), 
            col = col.smooth, ...)
  }
  
  panel.hist <- function(x, ...)
  {
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    opar=par(ps=10)
    h <- hist(x, plot = FALSE)
    breaks <- h$breaks; nB <- length(breaks)
    y <- h$counts; y <- y/max(y)
    rect(breaks[-nB], 0, breaks[-1], y, col="brown", ...)
  }
  
  pairs(mc_table,lower.panel=panel.smooth, upper.panel=panel.cor,diag.panel=panel.hist, 
          cex.labels = 1,font.labels = 2,main="Correlation Matrix")
  ######### clustering plots ####
  
  clust_mat <- t(mc_table)
  dist_mat <- dist(clust_mat, method = "euclidean")
  x <- hclust(dist_mat)
  dev.new()
  plot(x, main="Methylation Clustering", xlab="Samples")
  return(statistics_results)
}
)

## ----options,echo=FALSE-----------------------------------------------
options(width=72)

## ----mpload,message=FALSE,cache=TRUE----------------------------------
library(methylPipe)
library(BSgenome.Hsapiens.UCSC.hg18)

## ----methcall,message=FALSE,cache=TRUE--------------------------------
file_loc <- system.file('extdata', 'test_methcall', package='methylPipe')
meth.call(files_location=file_loc, output_folder=tempdir(), no_overlap=TRUE, 
          read.context="CpG", Nproc=1)

## ----bsprepare,message=FALSE,cache=TRUE-------------------------------
file_loc <- system.file('extdata', 'H1_chr20_CG_10k.txt', package='methylPipe')
#BSprepare(files_location=file_loc,output_folder=file_loc, tabix="/path-to-tabix/")
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', 
                      package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
H1.db

## ----bsdataset,message=TRUE,cache=TRUE--------------------------------
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', 
                         package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- BSdataSet(org=Hsapiens, group=c("C","E"), IMR90=IMR90.db, H1=H1.db)
H1.IMR90.set

## ----met1,fig.width=6,fig.height=5,out.width='.85\\textwidth',message=FALSE,cache=TRUE----
gr <- GRanges("chr20",IRanges(1,5e5))
sres <- mCsmoothing(H1.db, gr, Scorefun='sum', Nbins=50, plot=TRUE)

## ----desstats,fig.width=6,fig.height=5,out.width='.85\\textwidth',message=FALSE, fig.keep="all",fig.show="asis",cache=TRUE----
stats.set <- BSdataSet(org=Hsapiens, group=c("C","C","E","E"), IMR_1=IMR90.db, 
IMR_2=IMR90.db, H1_1=H1.db,H1_2=H1.db)
stats_res <- methstats(stats.set,chrom="chr20",mcClass='mCG', Nproc=1)
stats_res

## ----met2,message=FALSE,cache=TRUE------------------------------------
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
resmC <- mapBSdata2GRanges(GenoRanges=GR_chr20, Sample=H1.db, context='CG')
head(resmC[[4]])

## ----met3,message=FALSE,cache=TRUE------------------------------------
gec.H1 <- profileDNAmetBin(GenoRanges=GR_chr20, Sample=H1.db, mcCLASS='mCG', nbins=3)
binmC(gec.H1)[4:5,]
binC(gec.H1)[4:5,]
binrC(gec.H1)[4:5,]

## ----subset,message=FALSE,cache=TRUE----------------------------------
gec1 <- gec.H1[start(gec.H1) < 153924]
gec2 <- gec.H1[start(gec.H1) > 153924]

## ----gecset,message=FALSE,cache=TRUE----------------------------------
gecIMR_file <- system.file('extdata', 'gec.IMR90.Rdata', package='methylPipe')
load(gecIMR_file)
gel <- GElist(gecIMR90=gec.IMR90, gecH1=gec.H1)
print(names(gel))

## ----pmeth,fig.width=5,fig.height=5,out.width='.85\\textwidth',message=FALSE,cache=TRUE----
library(TxDb.Hsapiens.UCSC.hg18.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg18.knownGene
gel <- GElist(gecIMR90=gec.IMR90[1:10], gecH1=gec.H1[1:10])
plotMeth(gel, colors=c("red","blue"), datatype=c("mC","mC"), yLim=c(.025, .025), brmeth=list(IMR90=IMR90.db, H1=H1.db),
         mcContext="CG", transcriptDB=txdb, chr="chr20", start=14350, end=277370, org=Hsapiens)

## ----dmr1,message=FALSE,cache=TRUE------------------------------------
DMRs <- findDMR(object= H1.IMR90.set, Nproc=1, ROI=GR_chr20, MCClass='mCG',
     dmrSize=6, dmrBp=800)
head(DMRs)

## ----dmr2,message=FALSE,cache=TRUE------------------------------------
hyper.DMRs.conso <- consolidateDMRs(DmrGR=DMRs, pvThr=0.05, GAP=100, type="hyper")
hyper.DMRs.conso[1:4]

## ----info,echo=TRUE---------------------------------------------------
sessionInfo()

%\VignetteIndexEntry{methylPipe}
%\VignetteEngine{knitr::knitr}
%\VignetteKeywords{methylation, epigenetics}
%\VignetteDepends{methylPipe}
%\VignettePackage{methylPipe}

\documentclass[11pt]{article}
\usepackage[margin=2cm,nohead]{geometry}

\usepackage{hyperref}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}


\newcommand{\software}[1]{\textsf{#1}}
\newcommand{\R}{\software{R}}
\newcommand{\Bioconductor}{\software{Bioconductor}}
\newcommand{\methylPipe}{\Rpackage{methylPipe}}

\title{methylPipe}
\author{Kamal Kishore, Mattia Pelizzola}

\begin{document}


\maketitle
<<options,echo=FALSE>>=
options(width=72)
@

\tableofcontents



\section{Introduction} 
In this document you can find a brief tutorial on the \textbf{\Rpackage{methylPipe}} package 
for the analysis of base-pair resolution DNA methylation data. DNA methylation is a 
potentially heritable epigenetic modification of the genomic DNA typical of most 
eukaryotic organisms and critical for the regulation of gene transcription. 
The level of DNA methylation varies according to age, diet and environment and 
an appropriate control of methylation patterns is important for the onset of 
cellular differentiation processes and can be deregulated in diseases as cancer. 
In eukaryotic genomes the methyl group can be added to Cytosines in the CG, CHG 
and CHH sequence context (H being one of A, C or T). It is nowadays possible to 
generate genome-wide base-pair resolution DNA methylation 
maps (see Lister R et al Nature 2009). \textbf{\Rpackage{methylPipe}} is an R package that 
includes a series of objects and methods for a memory efficient 
management, query, analysis and visualization of DNA methylation data and their 
integration with heterogeneous data types. This package has been developed alongwith 
\textbf{\Rpackage{compEpiTools}} which provide functions and methods for the analysis
of epigenomics data. The data package \textbf{\Rpackage{ListerEtAlBSseq}} has also been
developed which consists of base resolution Bisulfite sequencing data of H1 and IMR90 
cell line (Lister R et al Nature 2009). 

The overview section of this document will briefly walk you through the main 
available functionalities, while the following sections will provide 
additional details on a selection of available classes and methods. 

\section{Quick overview}
A number of \textbf{classes} are defined in \Rpackage{methylPipe}: \Rclass{BSdata}, 
\Rclass{BSdataSet}, \Rclass{GEcollection} and \Rclass{GElist}.
\begin{itemize}
\item \textbf{\Rclass{BSdata}} is a reference class to store base resolution DNA methylation data generated 
from a high-thoughput sequencing experiment for a given biological sample.
\item The \textbf{\Rclass{BSdataSet}} class allows combining DNA methylation data for several 
samples for the same organism.
\item The \textbf{\Rclass{GEcollection}} class is used to store the DNA methylation status 
of a collection of genomic regions.
\item The \textbf{\Rclass{GElist}} class is the list of multiple objects of class \Rclass{GEcollection}. 
\end{itemize}


\textbf{\Rpackage{methylPipe}} consists of methods which allows analysis and visualisation of 
genome wide DNA methylation data. The \Rfunction{meth.call} function processes methylation 
information from aligned files and creates tabular data file. \Rfunction{BSprepare} processes 
and tabix compresses such tabular data files for creation of a \Rclass{BSdata} object for each sample.  
The \Rclass{BSdataSet} classe stores multiple such samples of class \Rclass{BSdata}.
The \Rmethod{mCsmoothing} methods extracts DNA methylation data for a given genomic region
and smooths/plots it.   

For methylation analysis on your regions of interest \Rclass{GEcollection} 
and \Rclass{GElist} acts as a repository of methylation data across various genomic ranges. 
\Rfunction{getCpos} and \Rfunction{getCposDensity} retrieves all potential genomic cytosine positions 
and their density across genomic regions, repectively. \Rfunction{mapBSdata2GRanges} 
allows extraction of DNA methylation information across multiple genomic ranges and 
\Rfunction{profileDNAmetBin} determines the absolute and relative methylation to create
a \Rclass{GEcollection} object. Different methods for the detection of differentially methylated 
regions are implemented, according to the number of samples (see \Rmethod{findDMR} and 
\Rfunction{consolidateDMRs}). In addition the methylation profile can be visualised using \Rfunction{plotMeth}. 
Morover, integrative analysis with other epignomics dataset can be performed by using \Rfunction{heatmapdata}, 
\Rfunction{heatmapPlot} functions of the package \textbf{\Rpackage{compEpiTools}}.

The methods that are most demanding in terms of computational resources are optimized for
low memory fingerprint and multi-processor support. \Rpackage{methylPipe} includes a 
series of objects and methods that can be used as building blocks for the creation of 
pipelines for the data analysis of epigenomics data, with particular emphasis on DNA 
methylation, and their integration with any kind of annotation or additional data type.

\section{Profiling Genome wide DNA methylation}
First of all the \Rpackage{methylPipe} and the genome sequence libraries are loaded:
<<mpload,message=FALSE,cache=TRUE>>=
library(methylPipe)
library(BSgenome.Hsapiens.UCSC.hg18)
@
The DNA methylation information can be read from a text file. See the documentation of 
the \Rfunction{BSprepare} on how to build data suitable to populate a \Rclass{BSdata} object. 
Moreover, the methylation information can also be read directly from the sorted SAM file(s) 
generated from the BISMARK aligner. The function \Rfunction{meth.call} process the sorted 
SAM file. The user can specify the sequence context in which the methylation information is read from these files 
either "CpG" or "All". In case of whole genome Bisulfite data especially in case of non-CG methylation the 
number of potential methylation sites are enormous and vast majority of them are unmethylated.
In order to avoid storing too much data while maintaining the ability to identify 
methylated, unmethylated and uncovered Cytosines, \Rpackage{methylPipe} only stores and access 
C positions with at least 1 mC read. Genomic regions not covered by sequencing are stored
as a \Rclass{GRanges} object. The function \Rfunction{meth.call} produces methylation call text file 
and uncovered genomic regions file for each sample in the output folder. Finally, when profiling DNA methylation 
unmethylated Cs are determined as those genomic cytosines not having any methylated reads and not belogning to uncovered genomic 
regions. 
<<methcall,message=FALSE,cache=TRUE>>=
file_loc <- system.file('extdata', 'test_methcall', package='methylPipe')
meth.call(files_location=file_loc, output_folder=tempdir(), no_overlap=TRUE, 
          read.context="CpG", Nproc=1)
@

\Rpackage{methylPipe} adopts TABIX compressed indexing of flatfiles to reduce disk space which allows fast access.
The \Rpackage{methylPipe} library includes a small subset of the first two base resolution human DNA methylomes 
(Lister R et al Nature 2009) for two well known human cell lines: embryonic stem cells (H1) 
and fetal lung fibroblasts (IMR90). The methylation data can be stored into \Rclass{BSdata} objects and then collected together within a \Rclass{BSdataSet} object. The \Rclass{BSprepare} command is not run in the following example since it requires a local copy of tabix software. Hence, for this example we use pre-generated tabix indexed files from \Rpackage{methylPipe} for H1 and IMR90.
<<bsprepare,message=FALSE,cache=TRUE>>=
file_loc <- system.file('extdata', 'H1_chr20_CG_10k.txt', package='methylPipe')
#BSprepare(files_location=file_loc,output_folder=file_loc, tabix="/path-to-tabix/")
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', 
                      package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
H1.db
@
Multiple \Rclass{BSdata} objects can be stored in \Rclass{BSdataSet} object by specifying group name for each sample either as "C" (control) or "E" (Experiment):
<<bsdataset,message=TRUE,cache=TRUE>>=
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', 
                         package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- BSdataSet(org=Hsapiens, group=c("C","E"), IMR90=IMR90.db, H1=H1.db)
H1.IMR90.set
@

The data includes the chromosome, the genomic position, strand and sequence context for each 
methylCytosine (mC). In addition, for each mC the number of reads with C at that genomic 
position and strand (supporting DNA methylation), the number of reads with T (evidence of an 
unmethylated C) and the binomial p-value supporting the mC call are attached.
Importantly, these data are referenced into the \Rclass{BSdata} but they are not actually 
loaded into the memory. The \Rmethod{mCsmoothing} method allow uploading into memory the 
DNA methylation data for a given genomic region and to display their methylation profile over it. The
smoothing can be performed by either "sum" or "mean" of methylation level for each regions. 
\begin{center}
<<met1,fig.width=6,fig.height=5,out.width='.85\\textwidth',message=FALSE,cache=TRUE>>=
gr <- GRanges("chr20",IRanges(1,5e5))
sres <- mCsmoothing(H1.db, gr, Scorefun='sum', Nbins=50, plot=TRUE)
@
\end{center}

\section{Descriptive statistics of DNA methylation}

\Rpackage{methylPipe} allows checking the basic stats about the methylation data such as range, mean and quantile distribution of methylation and assess sample similarity with correlation and clustering analysis. The \Rfunction{methstats} method computes pairwise correlation coefficients (Pearson) between the methylation profiles across all the samples in \Rclass{BSdataSet} object. It outputs scatter plot matrix of correlation coefficients. Finally, it performs (eucledian distance based) hierarchical clustering of samples and outputs the dendrogram. In the example below, the analysis is performed on \Rclass{BSdataSet} object of artificially replicated H1 and IMR90.
\begin{center}
<<desstats,fig.width=6,fig.height=5,out.width='.85\\textwidth',message=FALSE, fig.keep="all",fig.show="asis",cache=TRUE>>=
stats.set <- BSdataSet(org=Hsapiens, group=c("C","C","E","E"), IMR_1=IMR90.db, 
IMR_2=IMR90.db, H1_1=H1.db,H1_2=H1.db)
stats_res <- methstats(stats.set,chrom="chr20",mcClass='mCG', Nproc=1)
stats_res
@
\end{center}

\section{Profiling DNA methylation on genomic ranges}

\Rpackage{methylPipe} allows profiling DNA methylation over a set of genomic regions and determining 
their absolute or relative methylation profiles. Absolute methylation is here defined as the genomic 
density of mC calls per bp, while relative methylation is the proportion of density of methylated 
genomic sites over the density of potential methylation sites.

The \Rfunction{mapBSdata2GRanges} method retrieves mC calls given a \Rclass{BSdata} object of a sample and 
a set of genomic regions. In the following example we will extract the CG sites for a set of genomic 
regions. In particular we will consider a \Rclass{GRanges} object of genomic regions that spans 2Kb upstream
and downstream the TSS of the transcript ids on the first 500Kb of chromosome 20: 
<<met2,message=FALSE,cache=TRUE>>=
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
resmC <- mapBSdata2GRanges(GenoRanges=GR_chr20, Sample=H1.db, context='CG')
head(resmC[[4]])
@
To profile DNA methylation on genomic regions of interest the \Rclass{GEcollection} class 
(collection of genomic regions) is used. These genomic regions can be any regions of interest
such as one or more gene loci, promoter regions, a set of transcription factor binding sites, 
a set of regions enriched by some histone mark or a set of transposable elements. Most of 
these regions can be usually retrieved from either publications or public databases like 
the UCSC Genome Browser and its Table Browser tools (see \Rpackage{compEpiTools} for methods 
for generation/manipulation of these regions). The \Rclass{GEcollection} class has 
data slots and methods tailored for storing and analyzing DNA methylation data. 
It is an extension of the \Rclass{RangedSummarizedExperiment} class from the \Rpackage{SummarizedExperiment} package. 

For the creation of the \Rclass{GEcollection}, the \Rfunction{getCpos} and \Rfunction{mapBSdata2GRanges} 
methods are called automatically to populate its various data slots. Further arguments of 
the latter function allows to filter the mC sites based on the depth of sequencing, number
of reads with C at that genomic position and their binomial p-value. The \Rfunction{profileDNAmetBin} 
method acts as a wrapper for these methods to profile absolute and relative DNA methylation for a 
set of regions within a \Rclass{GEcollection}. In particular for each genomic region, and possibly
each bin of it, the absolute methylation density (mC/bp), the density of possible methylation sites 
(C/bp) and the relative methylation level (mC/C) will be determined. For example, in case of the 
CG context: mCG/bp, CG/bp and mCG/CG densities will be stored for each bin of each genomic region in the 
binmC, binC and binrC data slots, respectively.
<<met3,message=FALSE,cache=TRUE>>=
gec.H1 <- profileDNAmetBin(GenoRanges=GR_chr20, Sample=H1.db, mcCLASS='mCG', nbins=3)
binmC(gec.H1)[4:5,]
binC(gec.H1)[4:5,]
binrC(gec.H1)[4:5,]
@
\Rclass{GEcollection} objects can be \textbf{subsetted and combined}. Subset can be useful to
work only on the regions on a particular strand and/or chromosome or chromosomal region.
<<subset,message=FALSE,cache=TRUE>>=
gec1 <- gec.H1[start(gec.H1) < 153924]
gec2 <- gec.H1[start(gec.H1) > 153924]
@
Multiple \Rclass{GEcollection} objects can be saved into a \Rclass{GElist} object. This can be 
convenient if there are many of them and if one would like to iteratively apply 
the same method to them, for example profiling DNA methylation for their genomic regions in the same sample.
<<gecset,message=FALSE,cache=TRUE>>=
gecIMR_file <- system.file('extdata', 'gec.IMR90.Rdata', package='methylPipe')
load(gecIMR_file)
gel <- GElist(gecIMR90=gec.IMR90, gecH1=gec.H1)
print(names(gel))
@
The \Rclass{GElist} objects can be visualized using \Rfunction{plotMeth}. This allows methylation data of 
various samples to be displayed together with the annotation information for the genomic regions of interest. 
Morover, various epigenomics data tracks can also be visualized together with the methylation information. 
See the documentation of the \Rfunction{plotMeth} for more details.
<<pmeth,fig.width=5,fig.height=5,out.width='.85\\textwidth',message=FALSE,cache=TRUE>>=
library(TxDb.Hsapiens.UCSC.hg18.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg18.knownGene
gel <- GElist(gecIMR90=gec.IMR90[1:10], gecH1=gec.H1[1:10])
plotMeth(gel, colors=c("red","blue"), datatype=c("mC","mC"), yLim=c(.025, .025), brmeth=list(IMR90=IMR90.db, H1=H1.db),
         mcContext="CG", transcriptDB=txdb, chr="chr20", start=14350, end=277370, org=Hsapiens)
@

\section{Differential DNA methylation}
The \Rmethod{findDMR} function can be used to identify differentially methylated regions 
(DMRs) for any sequence context (mCG, mCHG or mCHH). DMRs can be identified 
comparing the mC methylation levels (the proportion of methylated over total reads for a set of mC) 
between \textbf{two samples} or within a group of \textbf{N samples}, with the Wilcoxon or the 
Kruskal-Wallis non parametric test, respectively. Only cytosine positions covered in both the 
samples (pairwise analysis) or all the samples (multiple sample analysis) are considered for 
DMR identification. The algorithm uses dynamic sliding window approach which identifies DMRs
depending on methylated cytosine frequency and their relative distance. Moreover, to perform regions
specific analysis (such as promoter or CpG island centric) genomic regions could be specified 
and the alogirithm will report DMRs only within those regions, if any. In a first step, all the evaluated
regions are reported in the output with their corresponding statistical significance. The methylation difference 
is determined in terms of MethDiffPerc (percentage difference between the mean methylation of experiment and control) 
and log2Enrichment (log2 of mean methylation of experiment over control).
<<dmr1,message=FALSE,cache=TRUE>>=
DMRs <- findDMR(object= H1.IMR90.set, Nproc=1, ROI=GR_chr20, MCClass='mCG',
     dmrSize=6, dmrBp=800)
head(DMRs)
@
The \Rfunction{consolidateDMRs} function can be used to multiple-testing correct the DMRs and consolidate them according 
to their relative distance, type of DMRs and thresholds of p-value/Methylation difference/log enrichment. A final 
\Rclass{GRanges} object with the set of DMRs including p-value, methylation difference and log enrichment is provided:
<<dmr2,message=FALSE,cache=TRUE>>=
hyper.DMRs.conso <- consolidateDMRs(DmrGR=DMRs, pvThr=0.05, GAP=100, type="hyper")
hyper.DMRs.conso[1:4]
@


\newpage
\section{Session Information}
<<info,echo=TRUE>>=
sessionInfo()
@

\end{document}

\name{findPMDs}
\alias{findPMDs}
\alias{findPMDs,methylPipe,BSdata}
\alias{findPMDs,methylPipe,BSdata-method}
\alias{findPMDs-methods}
\alias{findPMDs,BSdata-method}
\title{Identifying Partially Methylated Domains (PMDs)}
\description{
  This function is a wrapper function to identify partially methylated domains (PMDs) in Bis-seq data.
}
\usage{
\S4method{findPMDs}{methylPipe,BSdata}(Object, Nproc=1, Chrs=NULL)
}
\arguments{
  \item{Object}{An object of class \link{BSdataSet}}
  \item{Nproc}{numeric; the number of processors to use, one chromosome
    is ran for each processor}
  \item{Chrs}{character; Chromosome on which PMDs are identified}
}
\details{This functions is a wrapper function of segmentPMDs method of package MethylSeekR. 
  This function trains a Hidden Markov Model (HMM) to detect partially methylated domains (PMDs) in Bis-seq data.
}
\value{
      A GRangesList object containing segments that partition the genome
     into PMDs and regions outside of PMDs. The object contains two
     metadata columns indicating the type of region (PMD/notPMD) and
     the number of covered (by at least 5 reads) CpGs (nCG) in the
     region. 
     }
\author{Kamal Kishore}
\seealso{
  \code{\link{findDMR}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
PMDs <- findPMDs(H1.db, Nproc=1, Chrs="chr20")
}

\name{BSdataSet-class}
\docType{class}
\alias{BSdataSet-class}
\alias{BSdataSet}
\alias{length,BSdataSet-method}
\alias{show,BSdataSet-method}

% Subset methods:
\alias{[[<-,BSdataSet,ANY,ANY-method}
\alias{[[,BSdataSet,ANY,ANY-method}
\alias{[,BSdataSet,ANY,ANY-method}
\alias{$,BSdataSet-method}
\alias{$,BSdataSet}


\title{Class "BSdataSet"}
\description{ This class is used in the methylPipe library to store a
  set of BSdata objects}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("BSdataSet",
    ...)} or using the function BSdataSet(org,Objlist,names), see below.}
\section{Slots}{
  \describe{
    \item{\code{Objlist}:}{Object of class \code{"list"} : a list with
      more than one item, where each item is a \link{BSdata} object}
    \item{\code{names}:}{Object of class \code{"character"} : vector of
      the names of the objects, i.e. the sample names}
    \item{\code{group}:}{Object of class \code{"character"} : indicating
conditions and replicates; replicated samples within the same condition
have to be assigned the same group name; if object has only two groups, 
"C"(control) and "E" (Experiment) should be specified as groups name}
    \item{\code{org}:}{refrence genome of class BSgenome}
  }
}
\section{Methods}{
  \describe{
    \item{"[["}{\code{signature(x = "BSdataSet")}: subsets the
      \link{BSdataSet} returning a specific \link{BSdata} object}
    \item{"[[<-"}{\code{signature(x = "BSdataSet")}: replaces the
      specific \link{BSdata} object in the \link{BSdataSet}}
    \item{"["}{\code{signature(x = "BSdataSet")}: subsets the
      \link{BSdataSet} returning another \link{BSdataSet}}
  }
}
\author{Mattia Pelizzola, Kamal Kishore}
\seealso{
  \code{\link{BSdata-class},\link{findDMR}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- BSdataSet(org=Hsapiens, group=c("C","E"), IMR90=IMR90.db, H1=H1.db)
}
\keyword{classes}

\name{tabixdata2GR}
\alias{tabixdata2GR}
\title{Convert the list returned by the function scanTabix into a GRanges}
\description{
  Helper function to convert the list returned by the function scanTabix into a GRanges. This
  function is not intended for the user to call directly.
}
\usage{
tabixdata2GR(x)
}
\arguments{
  \item{x}{list; the list returned by the function scanTabix}
}
\value{
  An object of class data frame.
}
\author{Mattia Pelizzola, Kamal Kishore}
\seealso{
  \link{BSdata-class}
}

\name{pool.reads}
\alias{pool.reads}
\title{Function to pool reads of replicates}
\description{
  Combine reads of replicates within a group.
}
\usage{
pool.reads(files_location)
}
\arguments{
  \item{files_location}{character; the path to the folder location consisting of tab separated text files}
}
\details{The function reads tab separated text files of methylation calls generated from \link{meth.call} or user supplied
  according to the format specified for \link{BSprepare} method. It pools all the reads of the replicates within a single
  group for each cytosine position and creates a file consisting of the cytosines with pooled reads information.
}
\value{
  A text file of methylation calls are generated in the "files_location" folder.
}
\author{Kamal Kishore}
\seealso{
  \code{\link{BSprepare}}
}
\examples{
#pool.reads(files_location)
}

\name{plotMeth}
\alias{plotMeth}
\title{Plot DNA methylation together with other omics, or annotation data for a genomic region}
\description{
  Plot DNA methylation data (either high- or low-resolution) together with other omics data (ChIP-seq, RNA-seq), or annotation tracks for one genomic region (genome-browser like view based on gviz).
}
\usage{
plotMeth(grl=NULL, colors=NULL, datatype=NULL, yLim, brmeth=NULL, mcContext="CG", annodata=NULL, 
transcriptDB, chr, start, end, org)
}
\arguments{
  \item{grl}{An object of class \link{GElist} or a potentially mixed \link{list} of \link{GRanges} or \link{GEcollection} objects}
  \item{colors}{character of length equal to grl; name of colors to display data tracks from the grl object}
  \item{datatype}{character of length equal to grl; one of C, mC , rC, density or cols}
  \item{yLim}{numeric vector with the same length of grl setting
    maximum values}  
  \item{brmeth}{A list of object of class \link{BSdata}}
  \item{mcContext}{character; one of all, CG, CHG or CHH} 
  \item{annodata}{An object of class \link{GRangesList}}
  \item{transcriptDB}{An object of class TranscriptDb}
  \item{chr}{character; chromosome name}
  \item{start}{numeric; chromosome start}
  \item{end}{numeric; chromosome end}
  \item{org}{BSgenome; an object of class BSgenome}
}
\details{
This function can be used to display for one genomic region (genome-browser like) DNA methylation data together with other omics data or static annotation info. The genomic region is indicated by chr, start and end. Specifically, grl is used to display binned high- or low-resolution data, while brmeth is used to point to (unbinned) base-resolution data. Each component of grl can either be a GEcollection or a GRanges.

In case of GEcollection, binC, binmC or binrC components will be extracted as indicated in datatype (setting C, mC or rC, respectively), and if more than 1 bin is present the average value will be considered for each range. Datatype can be set to density to extract the binscore component of the GEcollection, which can be used to store low-resolution or other omics data attacched to a base-resolution dataset.

In case of a GRanges (suitable for low-resolution or other omics data independently from base-resolution data), only the 1st column of the mcols will be considered. Eventually, for both GEcolleciton and GRanges tracks, a bar with the specific value will be displayed for the ranges occurring in the considered region (if any).

Regarding unbinned base-resolution data, mcContext defines the sequence context to be considered for the methyl-cytosines for each component of the brmeth object; a bar with height equal to the methylation level of each cytosine will be displayed for each sample (track).

Annodata is an optional GRangesList that can be used to display co-occurring annotation data, such as CpG islands (presence or absence of the regions only).
transcriptDB and BSgenome are used to overlay the structure of annotated genes and chromosome ideogram, respectively.
}
\author{Kamal Kishore}
\examples{
require(TxDb.Hsapiens.UCSC.hg18.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg18.knownGene
require(BSgenome.Hsapiens.UCSC.hg18)
gecH1_file <- system.file('extdata', 'gec.H1.Rdata', package='methylPipe')
load(gecH1_file)
gecIMR_file <- system.file('extdata', 'gec.IMR90.Rdata', package='methylPipe')
load(gecIMR_file)
gel <- GElist(gecH1=gec.H1, gecIMR90=gec.IMR90)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- list(H1=H1.db, IMR90=IMR90.db)
plotMeth(gel, colors=c("red","blue"), datatype=c("mC","mC"), yLim=c(.025, .025), brmeth=H1.IMR90.set, mcContext="CG", transcriptDB=txdb, chr="chr20", start=14350 , end=474481, org=Hsapiens)
}

\name{BSprepare}
\alias{BSprepare}
\title{Preparing tabular data to be used to feed a BSdata object}
\description{
  Appending p-values and TABIX compressing tabular data containing
  DNA-methylation data so that they can be used to create a BSdata
  object.
}
\usage{
BSprepare(files_location, output_folder, tabixPath, bc=1.5/100)
}
\arguments{
  \item{files_location}{character; the path to the files}
  \item{output_folder}{character; the path to the output files}
  \item{tabixPath}{character; the path to the Tabix application folder}
  \item{bc}{numeric; combined bisulfite conversion and sequencing error rate}
}
\details{This function can be used to convert tabular files containing
  DNA-methylation base-resolution data so that they can be used to
  create a BSdata object. Genomic coordinates in the 1-base system are
  required, i.e. the first base of each chromosome should be at position 1.
  Files have to be tab-delimited and they have to contain the
  following columns:
  chromosome assignment (in the form chr1, .., chr22, chrX, chrY, chrM, chrC),
  genomic position (positive integer),
  strand (either - or +),
  methylation sequence context (either CG, CHG or CHH),
  number of sequencing reads with C calls (>0) at that genomic position,
  number of sequencing reads with T calls at that genomic position.
  Each file has to be sorted by genomic coordinate.}
\value{
  Binomial p-values are added and a compressed file is created together with the Tabix index.
  P-values indicate for each Cytosine the probability of observing by chance the occurrence of unmethylated reads.
  The lower the p-value the higher the confidence in calling that Cytosine methylated.
}
\author{Mattia Pelizzola, Kamal Kishore}
\seealso{
  \code{\link{BSdata-class}}
}
\examples{
#BSprepare("/path-to-input/","/path-to-output/", tabix="/path-to-tabix/tabix-0.2.6")
}

\name{splitChrs}
\alias{splitChrs}
\title{Partitioning genome in chunks, for parallel computation}
\description{
  Helper function to partition genome chromosome-wise for parallel computation. This
  function is not intended for the user to call directly.
}
\usage{
splitChrs(chrs, org)
}
\arguments{
  \item{chrs}{character; an aray of chromome names in the form chr1, .., chrX}
  \item{org}{an object of class BSgenome}
}
\value{
  A data frame with chromosome name, start and end position of each chunk.
}

\name{findDMR}
\alias{findDMR}
\alias{findDMR,methylPipe,BSdataSet}
\alias{findDMR,methylPipe,BSdataSet-method}
\alias{findDMR-methods}
\alias{findDMR,BSdataSet-method}
\title{Identifying Differentially Methylated Regions (DMRs)}
\description{
  Identifying differentially methylated regions for pairwise or multiple
  samples comparision.
}
\usage{
\S4method{findDMR}{methylPipe,BSdataSet}(object, Nproc=NULL, ROI=NULL,
pmdGRanges=NULL, MCClass='mCG', dmrSize=10, dmrBp=1000, binsize=0,
eprop=0.3, coverage=1, Pvalue=NULL, SNPs=NULL)
}
\arguments{
  \item{object}{An object of class \link{BSdataSet}}
  \item{Nproc}{numeric; the number of processors to use, one chromosome
    is ran for each processor}
  \item{ROI}{character; either NULL or an object of class GRanges
    consisting of genomic regions of interest for which DMRs are
    identified}
  \item{pmdGRanges}{a \link{GRanges} object containing the genomic
    coordinates of Partially Methylated Domains that will be masked}
  \item{MCClass}{character; the mC sequence context to be considered,
    one of all, mCG, mCHG or mCHH}
  \item{dmrSize}{numeric; the number of consecutive mC to be
    simulataneously considered; atleast 5}
  \item{dmrBp}{numeric; the max number of bp containing the dmrSize mC}
  \item{binsize}{numeric; the size of the bin used for smoothing the
    methylation levels, useful for nonCG methylation in human}
  \item{eprop}{numeric; the max - min methylation level is determined
    for each mC, or for each bin, and only mC (or bins) with
    difference greater than eprop are considered}
  \item{coverage}{numeric; the minimum number of total reads at a given
    cytosine genomic position}
  \item{Pvalue}{numeric; to select only those mC with significant p-value}
  \item{SNPs}{GRanges; if SNPs information is provided those cytosine
    are removed from DMR computation}
}
\details{Typically for nonCG methylation in human a dmrSize of 50, a
  dmrBp of 50000 and a binsize of 1000 are used. For CpG methylation in
  human and both CpG and nonCG methylation in plants the default
  settings are usually fine. Partially Methylated Domains are usually
  found in differentiated cells and can constitute up to one third of
  the genome (Lister R et al, Nature 2009). Usually DMRs are not
  selected within those regions especially when comparing differentiated
  and pluripotent cells. Eprop is used to speed up the
  analysis. According to the number of samples different test are used
  to compare the methylation levels (percentage of methylated reads for
  each mC). In case of two samples the non parametric wilcoxon test is
  used. In case of more than two samples the kruskal wallis non
  parametric testis used. Check \code{\link{consolidateDMRs}} to further
  process and finalize the list of DMRs.
}
\value{
  A \link{GRanges} object of DMRs with the metadata slots for pValue,
  MethDiff_Perc and log2Enrichment. When two samples are compared, MethDiff_Perc is the
  diference between percentage methylation between the conditions compared. However, log2Enrichment 
  is the log2ratio between the mean for the samples. 
}
\author{Mattia Pelizzola, Kamal Kishore}
\seealso{
  \code{\link{consolidateDMRs}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- BSdataSet(org=Hsapiens, group=c("C","E"), IMR90=IMR90.db, H1=H1.db)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
DMRs <- findDMR(object= H1.IMR90.set, Nproc=1, ROI=GR_chr20, MCClass='mCG',
dmrSize=10, dmrBp=1000, eprop=0.3)
head(DMRs)
}

\name{BSdata-class}
\docType{class}
\alias{BSdata-class}
\alias{BSdata}
\alias{show,BSdata-method}

\title{Class "BSdata"}
\description{ This class is used in the methylPipe library to point to a
  TABIX compressed file containing base-resolution DNA-methylation data
  and reference genome sequence}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("BSdata", ...)}
  or using the function BSdata(file, uncov, org) whose arguments are
  described in the next section Slots.
}
\section{Slots}{
  \describe{
    \item{\code{file}:}{Object of class \code{"character"} : the TABIX
      compressed file containing base-resolution DNA-methylation data.
      This file can be generated through the \code{\link{BSprepare}}
      function, and it must contain the following columns:
      chromosome assignment (in the form chr1, chr2...),
      genomic position (positive integer),
      strand (either - or +),
      methylation sequence context (either CG, CHG or CHH),
      number (>0) of sequencing reads with C calls at that genomic position,
      number of sequencing reads with T calls at that genomic position,
      binomial pvalue (-10*log10(pvalue)) for calling a mC at that position.}
    \item{\code{uncov}:}{Object of class \link{GRanges} : this
      \link{GRanges} object consists of the list of genomic regions with
      sequencing coverage information; this information is used to distinguish
      which methylation sites are unmethylated, but covered, from those
      that are missing data since they have no sequencing coverage. This
      object is automatically generated by the \code{\link{meth.call}}
      function while processing aligned files generated from the aligner.}
    \item{\code{org}:}{refrence genome of class BSgenome}
  }
}
\author{Mattia Pelizzola}
\seealso{
  \code{\link{BSprepare},\link{mCsmoothing}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
}
\keyword{classes}

\name{getCpos}
\alias{getCpos}
\alias{getCposChr}
\title{Get genomic Cxx positons for a series of genomic regions}
\description{
  getCpos retrieves genomic Cxx positions, possible target of DNA
  methylation for a series of genomic regions (and bins thereof) and a
  given organism. getCposChr is a Helper function which performs the same
  task for any given DNAString sequence and is not intended for the user
  to call directly.
}
\usage{
getCpos(GenoRanges, seqContext='all', nbins, org)
getCposChr(GenoRanges, seqContext, chrseq, nbins)
}
\arguments{
  \item{GenoRanges}{An object of class \link{GRanges}}
  \item{seqContext}{character; one of: all, CG, CHG or CHH}
  \item{org}{an object of class BSgenome; typically the genome
    sequences of a given organism}
  \item{chrseq}{an object of class \link{DNAString}; typically a
    chromosome sequence of a given organism}
  \item{nbins}{numeric; the number of bins each region of genomic
    regions is divided}
}
\value{
  A list is returned with the position of the Cxx in the \link{GRanges}
  regions. The length of the list is equal to the length of the
  \link{GRanges}. For each list item a list with length equal to the
  number of bins of the \link{GRanges} is returned. For each bin the
  position of the Cxx relative to the genomic coordinates of that bin is
  returned.
}
\author{Mattia Pelizzola}
\seealso{
  \code{\link{getCposDensity}}, \code{\link{profileDNAmetBin}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
res <- getCpos(GR_chr20, seqContext='CG', nbins=1, org=Hsapiens)
res[[1]]
}

\name{mCsmoothing}
\alias{mCsmoothing}
\alias{mCsmoothing,methylPipe,BSdata}
\alias{mCsmoothing,methylPipe,BSdata-method}
\alias{mCsmoothing-methods}
\alias{mCsmoothing,BSdata-method}

\title{Smoothing and plotting methylation data}
\description{
  Smoothing and plotting methylation data, even chromosome wide.
}
\usage{
\S4method{mCsmoothing}{methylPipe,BSdata}(Object, refgr, Scorefun='sum', Nbins=20,
Context="CG", plot=TRUE)
}
\arguments{
  \item{Object}{An object of class \link{BSdata}}
  \item{refgr}{GRanges; Genomic Ranges to plot the data}
  \item{Scorefun}{character; either sum or mean for smoothing}
  \item{Nbins}{numeric; the number of interval each range is divided}
  \item{Context}{character; either all or a combination of CG, CHG, and CHH}
  \item{plot}{logical; whether the smoothed profile has to be plotted}
}
\details{The sum or the mean methylation level is determined on each
  window of size Binsize and smoothed with the smooth.spline function.}
\value{
  A list with three components: pos (the left most point of each
  window), score (either the sum or the mean methylation levels),
  smoothed (the smoothed methylation levels).
}
\author{Mattia Pelizzola}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
gr <- GRanges("chr20",IRanges(1,5e5))
sres <- mCsmoothing(H1.db, gr, Scorefun='sum', Nbins=50, Context="CG", plot=TRUE)
}

\name{profileDNAmetBin}
\alias{profileDNAmetBin}
\alias{profileDNAmetBinParallel}
\title{Profile DNA methylation data for a set of genomic regions}
\description{
  Profile the absolute and relative density of mC sites for each bin of
  each genomic region of a \link{GEcollection} object.
}
\usage{
profileDNAmetBin(GenoRanges, Sample, mcCLASS="mCG",
mC=1, depthThr=0, mCpv=1, minCoverage=0.75, nbins = 2)
profileDNAmetBinParallel(GenoRanges, Sample, mcCLASS="mCG", mC=1,
depthThr=0, mCpv=1, minCoverage=0.75, Nproc=1, nbins = 2)
}
\arguments{
  \item{GenoRanges}{an object of class \link{GRanges}}
  \item{Sample}{an object of class \link{BSdata}}
  \item{mcCLASS}{character; one of: mCG, mCHG, mCHH}
  \item{mC}{numeric; the minumum number of reads with C (DNA-methylation
    events) at a given cytosine genomic position}
  \item{depthThr}{numeric; the minimum number of total reads at a given
    cytosine genomic position}
  \item{mCpv}{numeric; the minimum binomial pValue for an mC call at a
    given cytosine genomic position}
  \item{minCoverage}{numeric between 0 and 1; the minimum coverage of
    for the genomic region to be profiled; currently ignored}
  \item{Nproc}{numeric; the number of processor for parallelization}
  \item{nbins}{numeric; the number of bins each genomic region is divided}
}
\details{
  For each bin of each genomic region of a \link{GRanges} object, the
  absolute and relative density of mC sites is determined and an object
  of class \link{GEcollection} is created.
}
\value{
  An object of class \link{GRanges} from which an object of class
  \link{GEcollection} is created with the binC, binmC and binrC data
  slots been filled with density matrices.
  These matrices report the density of mC sites in the sequence context
  specified by mcCLASS. They are counted for each bin in each genomic
  region and their count is divided by the bin size in bp.
  The binC data slot is filled with the density of all possible
  methylation sites in the specified sequence context.
  The binmC data slot is filled with the density of mC sites in the
  specified sequence context for the considered sample.
  The binrC data slot is filled with the ratio of binC and binmC
  matrices, representing the relative methylation for each bin in each genomic region.
}
\author{Mattia Pelizzola, Kamal Kishore}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1.db <- BSdata(file=H1data, uncov= uncov_GR, org=Hsapiens)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
gec.H1 <- profileDNAmetBin(GenoRanges=GR_chr20, Sample=H1.db, mcCLASS='mCG', nbins=2)
head(binmC(gec.H1))
}

\name{process.hmc}
\alias{process.hmc}
\title{Processing hmC information from the MLML output}
\description{
  Processing MLML software output to generate files with hmC and CpG methylation information.
}
\usage{
process.hmc(file, output_folder, Coverage)
}
\arguments{
  \item{file}{character; the path to the file}
  \item{output_folder}{character; the path to the output files}
  \item{Coverage}{GRanges; the object containing coverage for each cytosine}
}
\details{This function allows processing of the output files from MLML software (Qu et al, Bioinformatics 2013).
  MLML read counts from BS-seq, oxBS-seq and TAB-seq to provide simultaneous estimates of 5hmC and 5mC levels. The
  input for this function is output file from this software alongwith a \link{GRanges} object consisting  of coverage
  of each cytosine. The \link{GRanges} object should contain "coverage" column. This object can be generated using the
  \link{coverage} method of R package \link{GenomicRanges}.
}
\value{
  The function will return two files one each for "CpG" and "hmC" for the given sample which can directly be used for \link{BSdata} object creation.
}
\author{Kamal Kishore}
\seealso{
  \code{\link{BSdata-class}}
}
\examples{
#process.hmc(file,"/path-to-output/", Coverage)
}

\name{GElist-class}
\docType{class}
\alias{GElist-class}
\alias{GElist}
\alias{show,GElist-method}
\alias{length,GElist-method}

% Subset methods:
\alias{[[<-,GElist,ANY,ANY-method}
\alias{[[,GElist,ANY,ANY-method}
\alias{[,GElist,ANY,ANY-method}
\alias{$,GElist-method}
\alias{$,GElist}


\title{Class "GElist"}
\description{ This class is used in the methylPipe library to collect a
  set of GEcollection objects}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("GElist", ...)}
  or using the function GElist(Objlist,names), see below.
  GElist are a collection of GEcollection objects (see
  \code{\link{GElist-class}}).
}
\section{Slots}{
  \describe{
    \item{\code{Objlist}:}{Object of class \code{"list"} : a list where
      each item is a \link{GEcollection} object}
    \item{\code{names}:}{Object of class \code{"character"} : vector of
      the names of the objects}
  }
}
\section{Methods}{
  \describe{
    \item{"[["}{\code{signature(x = "GElist")}: subsets the
      \link{GElist} returning a specific \link{GEcollection} object}
    \item{"[[<-"}{\code{signature(x = "GElist")}: replaces the specific
      \link{GEcollection} object in the \link{GElist}}
    \item{"["}{\code{signature(x = "GElist")}: subsets the \link{GElist}
      returning another \link{GElist}}
  }
}
\author{Mattia Pelizzola}
\seealso{
  \code{\link{GElist-class}}
}
\examples{
gecollect_file <- system.file('extdata', 'gec.H1.Rdata', package='methylPipe')
load(gecollect_file)
gec1 <- gec.H1[start(gec.H1) < 153924]
gec2 <- gec.H1[start(gec.H1) > 153924]
gel.set <- GElist(g1=gec1, g2=gec2)
}
\keyword{classes}

\name{GEcollection-class}
\docType{class}
\alias{GEcollection-class}
\alias{GEcollection}
\alias{show,GEcollection-method}
\alias{chr,GEcollection-method}
\alias{binC,GEcollection-method}
\alias{binmC,GEcollection-method}
\alias{binrC,GEcollection-method}
\alias{nbins,GEcollection-method}
\alias{length,GEcollection-method}
\alias{binscore,GEcollection-method}
\alias{binscore<-,GEcollection-method}
\alias{chr}
\alias{binC}
\alias{binmC}
\alias{binrC}
\alias{nbins}
\alias{binscore}
\alias{length}
\alias{binscore<-}

\title{Class "GEcollection"}
\description{ This class is used in the methylPipe library to define and
  manipulate a set of genomic regions and the associated DNA methylation
  patterns}
\section{Objects from the Class}{
  This class is an extension of the \link{RangedSummarizedExperiment} class
  from the \pkg{SummarizedExperiment} package. Objects can be created using
  the function \code{profileDNAmetBin} which determines the absolute and
  relative methylation level by filling the binC, binmC and binrC slots. The
  assays slot of the \link{RangedSummarizedExperiment} class here consists of
  four matrices:
\itemize{
\item binC: each genomic region is divided in one or more bins and for each
  bin the density (per bp) of potential methylation sites is determined.
\item binmC:
  each genomic region is divided in one or more bins and for each bin the
  density (per bp) of methylation events is determined.
\item binrC: each genomic region is
  divided in one or more bins and for each bin the relative mC/C content is
  determined.
\item binscore: each genomic region is divided in one or more bins and
  scores can be assigned to them. In particular, it can be convenient for
storing reads count for each bin of each genomic region.
}
 The minimal set of data
  to create a \link{GEcollection} object is a set of genomic regions to be provided as a
  \link{GRanges} object and a dataset of class \link{BSdata}.
}


\section{Methods}{
  \describe{
    \item{chr}{\code{signature(object = "GEcollection")}: extracts the
      chr assignment of the genomic regions}
    \item{Strand}{\code{signature(object = "GEcollection")}: extracts
      the strand assignment of the genomic regions}
    \item{binC}{\code{signature(object = "GEcollection")}: extracts the
      binC matrix}
    \item{binmC}{\code{signature(object = "GEcollection")}: extracts the
      binmC matrix}
    \item{binrC}{\code{signature(object = "GEcollection")}: extracts the
      binrC matrix}
    \item{binscore}{\code{signature(object = "GEcollection")}: extracts
      the binscore matrix}
    \item{binscore<-}{\code{signature(object = "GEcollection")}:
      replaces the binscore matrix}
    \item{nbins}{\code{signature(object = "GEcollection")}: returns the
      number of bins}
  }
}
\author{Kamal Kishore}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
gec.H1 <- profileDNAmetBin(GenoRanges=GR_chr20, Sample=H1.db, mcCLASS='mCG')
gec.H1
}
\keyword{classes}

\name{extractBinGRanges}
\alias{extractBinGRanges}
\title{Extract genomic ranges for a given bin}
\description{
  For genomic ranges with N bins, extract the Genomic ranges for a given bin.
}
\usage{
extractBinGRanges(GenoRanges, bin, nbins)
}
\arguments{
  \item{GenoRanges}{An object of class \link{GRanges}}
  \item{bin}{numeric; the bin corresponding to which data has to be extracted}
  \item{nbins}{numeric; the number of bins in which genomic regions are divided}
}
\value{
  A \link{GRanges} Object
}
\author{Mattia Pelizzola}
\seealso{
  \code{\link{mapBSdata2GRangesBin}}
}
\examples{
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
extractBinGRanges(GR_chr20, 2, 5)
}

\name{chiCombP}
\alias{chiCombP}
\title{Fisher's method implementation}
\description{
  Fisher's method implementation, used to combine the results from
  several independent tests bearing upon the same overall hypothesis.
}
\usage{
chiCombP(Pvalues)
}
\arguments{
  \item{Pvalues}{an array of pvalues}
}
\details{Pvalues will not be corrected for multiple testing. The sum of
  the log of the pvalues is determined (S). -2*S has a chi-square
  distribution with 2k degrees of freedom, where k is the number of
  tests being combined. A chi-square test is then performed.}
\value{
  The chi-square final pvalue
}
\author{Mattia Pelizzola}
\examples{
chiCombP(c(1e-3,1e-5,1e-2))
}

\name{methstats}
\alias{methstats}
\alias{methstats,methylPipe,BSdataSet}
\alias{methstats,methylPipe,BSdataSet-method}
\alias{methstats-methods}
\alias{methstats,BSdataSet-method}
\title{Exploratory statistics of samples in BSdataSet object}
\description{
  Exploratory methylation statistics of samples in BSdataSet object.
}
\usage{
\S4method{methstats}{methylPipe,BSdataSet}(object, chrom, mcClass='mCG', minC=1, coverage=1, pval=1, Nproc=1)
}
\arguments{
  \item{object}{An object of class \link{BSdataSet}}
  \item{chrom}{character; either NULL or an object of class character}
  \item{mcClass}{character; the mC sequence context to be considered,
    one of all, mCG, mCHG or mCHH}
  \item{minC}{numeric; the minumum number of reads with C (DNA-methylation
    events) at a given cytosine genomic position}
  \item{coverage}{numeric; the minimum number of total reads at a given
    cytosine genomic position}
  \item{pval}{numeric; the minimum binomial pValue for an mC call at a
    given cytosine genomic position}
  \item{Nproc}{numeric; the number of processors to use, one chromosome
    is ran for each processor}
}
\details{The function provides basic statistical methods which computes descriptive statistics, 
correlation matrix and clustering of samples within the BSdataSet. 
}
\value{
  A list with slots named descriptive_stats and correlation_mat.
}
\author{Kamal Kishore}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges('chr20', IRanges(14350, 18349))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
IMR90data <- system.file('extdata', 'IMR90_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
IMR90.db <- BSdata(file=IMR90data, uncov=uncov_GR, org=Hsapiens)
H1.IMR90.set <- BSdataSet(org=Hsapiens, group=c("C","C","E","E"), IMR_1=IMR90.db, 
IMR_2=IMR90.db, H1_1=H1.db,H1_2=H1.db)
stats_res <- methstats(H1.IMR90.set,chrom="chr20",mcClass='mCG', Nproc=1)
stats_res
}

\name{consolidateDMRs}
\alias{consolidateDMRs}
\title{Consolidating Differentially Methylated Regions (DMRs)}
\description{
  Joins differentially methylated regions according to their proximity
  to each other, statistical significance and methylation difference
}
\usage{
consolidateDMRs(DmrGR, pvThr=0.05, MethDiff_Thr=NULL, log2Er_Thr =NULL, GAP=0, type=NULL, correct=FALSE)
}
\arguments{
  \item{DmrGR}{the GRanges object resulting from the
    \code{\link{findDMR}} function}
  \item{pvThr}{numeric; the minimum pvalue for a DMR to be selected}
  \item{MethDiff_Thr}{numeric; the absolute value of minimum methylation
    difference percentage (for both hyper- and hypo-methyaltion) cutoff
    for the selection of a DMR}
  \item{log2Er_Thr}{numeric; the absolute value of minimum log2Enrichment
   (for both hyper- and hypo-methyaltion) cutoff for the selection of a DMR}
  \item{GAP}{numeric; the minimum distance between two adjacent DMRs;
    DMRs closer than that will be joined, resulting DMRs will be
    updated mean methylation difference and Pvalues combined using the
    Fisher's Method}
  \item{type}{character; one of the "hyper" or "hypo", specifies the type
    of differentially menthylated regions selected}
  \item{correct}{logical; whether to correct the pvalues using the
    Benjamini-Hochberg muliple testing correction method}
}
\details{After the DMRs are identified by \link{findDMR} method, a
  consolidation can be applied on them. This functions allows to select
  hyper/hypo differentially methylated regions based on P-value and
  absolute methylation change thresholds. Moreover, DMRs closer than a given
  distance can be joined. The final \link{GRanges} object
  with the set of final DMRs will be provided with updated mean
  methylation difference and Pvalues combined using the Fisher's Method.
}
\value{
  Either NULL or a \link{GRanges} object containing the differential
  methylated regions satisfying the criteria.
}
\author{Kamal Kishore}
\seealso{
  \code{\link{findDMR}}
}
\examples{
DMRs_file <- system.file('extdata', 'DMRs.Rdata', package='methylPipe')
load(DMRs_file)
hyper.DMRs.conso <- consolidateDMRs(DmrGR=DMRs, pvThr=0.05, GAP=100, type="hyper", correct=TRUE)
hyper.DMRs.conso
}

\name{meth.call}
\alias{meth.call}
\title{Function to read methylation calls}
\description{
  Reads the methylation calls from sorted SAM files generated from
  Bismark aligner.
}
\usage{
meth.call(files_location, output_folder, no_overlap, read.context, Nproc)
}
\arguments{
  \item{files_location}{character; the path(s) to the folder location
    consisting of sorted SAM files}
  \item{output_folder}{character; the path(s) to the folder location
    where the output files are written}
  \item{no_overlap}{character; if set to TRUE and the SAM file has
    paired-end reads, then one read of the overlapping paired-end read
    pair will be ignored for methylation calling}
  \item{read.context}{character; One of the 'CpG' or 'All'. Determines
    what type of methylation context will be read. If given as 'all',
    cytosine methylation information in all sequence context will be read.}
  \item{Nproc}{numeric; the number of processors to use, one sample
    is processed by each processor.}
}
\details{The function reads methylation calls from the sorted SAM file
  so that they can be used to create a \link{BSdata} object. SAM files
  must be sorted based on chr and start of reads. The user can specify
  the sequence context in which the methylation information is read from
  these files either "CpG" or "All". If "All" is specified, cytosine
  methylation in all context (CG, CHG or CHH) will be read. The
  methylation calls is saved as a text file in the output folder.
  These text files are tab-delimited and contain the following columns:
  chromosome assignment (in the form chr1, chr2..),
  genomic position (positive integer),
  strand (either - or +),
  methylation sequence context (either CG, CHG or CHH),
  number (>0) of sequencing reads with C calls at that genomic position,
  number of sequencing reads with T calls at that genomic position.
  In addition a GRanges object consisting of uncovered genomic regions is 
  generated and saved in the output folder for each sample. This information is
  used to distinguish unmethylated cytosines from those that are not covered by 
  sequencing. This GRanges object is used further to provide uncovered regions 
  information while creating BSdata object by \code{\link{BSdata}} method.
}
\value{
  A text file of methylation calls and a \link{GRanges} object
  consisting of uncovered genomic regions for each sample are generated
  in the "output_folder" folder. The files are prefixed with sample name.
}
\author{Kamal Kishore}
\seealso{
  \code{\link{BSprepare}}
}
\examples{
file_loc <- system.file('extdata', 'test_methcall', package='methylPipe')
meth.call(files_location=file_loc, output_folder=tempdir(), no_overlap=TRUE, read.context="CpG", Nproc=1)
}

\name{methylPipe-package}
\alias{methylPipe-package}
\alias{methylPipe}
\docType{package}
\title{Analysis of base-pair resolution DNA methylation data.}
\description{Analysis of base-pair resolution DNA methylation data.}
\details{
\tabular{ll}{
Package: \tab methylPipe\cr
Type: \tab Package\cr
Version: \tab 1.0.5 \cr
Date: \tab 2015-02-25 \cr
License: \tab GPL\cr
Depends: \tab methods\cr
}
The package offers the following functionalities:

\itemize{
\item BSdata-class :  This class is used in to point to a TABIX compressed file containing base-resolution DNA-methylation data and reference genome sequence  
\item mCsmoothing : Smoothing and plotting methylation data, even chromosome wide	    
\item findPMDs : Find partially methylated regions for a given sample    
\item mapBSdata2GRanges : Retrieve mC calls for a GRanges from a BSdata object for a sample 
\item BSdataSet-class : This class is a set of BSdata objects
\item findDMR : Identifying differentially methylated regions for pairwise or multiple samples comparision
\item methstats : Descriptive methylation statistics of samples within BSdataSet object
\item consolidateDMRs : Joins differentially methylated regions according to their proximity to each other, statistical significance, methylation difference and DMR type
\item GEcollection-class : This class is used to define and manipulate a set of genomic regions and the associated DNA methylation patterns
\item getCpos : Get genomic Cxx positons for a series of genomic regions	       
\item getCposDensity : Determines the density of genomic Cxx positions for a series of genomic regions
\item profileDNAmetBin : Profile DNA methylation data for a set of genomic regions
\item plotMeth : Plot the methylation/omics data of a GEcollection object	    
\item BSprepare : Preparing tabular data to be used to feed a BSdata object	    
\item meth.call : Reads the methylation information from the sorted SAM files generated from BISMARK aligner
\item pool.reads : Combine reads of replicates within a group  
\item GElist-class : This class is a set of GEcollection objects	
} 
}
\author{
Computational Epigenomics Unit at the Center for Genomic Sciences of IIT@SEMM, Milan, Italy

\email{kamal.fartiyal84@gmail.com}

\url{http://genomics.iit.it/groups/computational-epigenomics.html}
}
\keyword{ package }

\name{mapBSdata2GRanges}
\alias{mapBSdata2GRanges}
\alias{mapBSdata2GRangesBin}
\title{Retrieve mC calls for a GRanges set of genomic regions given a BSdata object for a sample}
\description{
  mapBSdata2GRanges retrieves mC calls for a \link{GRanges} given a \link{BSdata} object for a sample.
  mapBSdata2GRangesBin does the same for each bin of each genomic region.
}
\usage{
mapBSdata2GRanges(GenoRanges, Sample, context='all', mC=1, depth=0, pValue=1)
mapBSdata2GRangesBin(GenoRanges, Sample, context='all', mC=1, depth=0, pValue=1, nbins)
}
\arguments{
  \item{GenoRanges}{An object of class \link{GRanges}}
  \item{Sample}{An object of class \link{BSdata}}
  \item{context}{character; one of: all, CG, CHG or CHH}
  \item{mC}{numeric; the minumum number of reads with C (DNA-methylation
    events) at a given cytosine genomic position}
  \item{depth}{numeric; the minimum number of total reads at a given
    cytosine genomic position}
  \item{pValue}{numeric; the minimum binomial pValue for an mC call at a
    given cytosine genomic position}
  \item{nbins}{numeric; the number of bins in which Genomic regions are
    divided}
}
\details{DNA-methylation data contained for a sample within a
  \link{BSdata} object is extracted for the set of genomic regions of a
  \link{GRanges} (and in particular for each bin using the
  mapBSdata2GRangesBin method).
  It is also possible to restrict the mC sequence context, to specify the
  minimal number of reads with C events at a given cytosine genomic
  position, to specify the minimum depth of sequencing and binomial
  pValue for the mC calls. A region with no mC will be defined
  unmethylated (0 is returned for that region). However, if it is
  overlapping with at least one uncovered region then it is defined non
  evaluable (NA is retuned).}
\value{
  A list is returned. The length of the list is equal to the length of
  the \link{GRanges}. For each list item either NA, 0 or a data frame
  are returned.
  0 means that the region contains unmethylated DNA methylation sites,
  whereas NA indicates that the region or some part of region was not
  covered by the sequencing.
  If a data frame is returned, it has the following columns:
  chromosome assignment (in the form chr1, .., chr22, chrX, chrY, chrM, chrC),
  genomic position (positive integer), strand (either - or +),
  methylation sequence context (either CG, CHG or CHH),
  number (>0) of sequencing reads with C calls at that genomic position,
  number of sequencing reads with T calls at that genomic position,
  binomial pvalue (-10*log10(pvalue)) for calling a mC at that position.
}
\author{Mattia Pelizzola, Kamal Kishore}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
uncov_GR <- GRanges(Rle('chr20'), IRanges(c(14350,69251,84185), c(18349,73250,88184)))
H1data <- system.file('extdata', 'H1_chr20_CG_10k_tabix_out.txt.gz', package='methylPipe')
H1.db <- BSdata(file=H1data, uncov=uncov_GR, org=Hsapiens)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
res <- mapBSdata2GRanges(GenoRanges=GR_chr20, Sample=H1.db, context='CG', mC=1, depth=0, pValue=1)
resbin <- mapBSdata2GRangesBin(GenoRanges=GR_chr20, Sample=H1.db, context='CG', mC=1, depth=0, pValue=1, nbins=2)
}

\name{getCposDensity}
\alias{getCposDensity}
\title{Determines the density of genomic Cxx positions for a series of
  genomic regions}
\description{
  After having used getCpos (or getCposChr), getCposDensity determines
  the density of Cxx sites for each bin of each genomic region.
}
\usage{
getCposDensity(GenoRanges, Cpos, nbins)
}
\arguments{
  \item{GenoRanges}{an object of class \link{GRanges} used to generate
    the Cpos list}
  \item{Cpos}{list returned by getCpos or getCposChr methods}
  \item{nbins}{numeric; the number of bins each region of genomic
    regions is divided}
}
\value{
  Returns a list with the number of Cxx sites per bp of bin size for
  each region of the \link{GRanges}.
}
\author{Mattia Pelizzola}
\seealso{
  \code{\link{getCpos}}, \code{\link{profileDNAmetBin}}
}
\examples{
require(BSgenome.Hsapiens.UCSC.hg18)
gr_file <- system.file('extdata', 'GR_chr20.Rdata', package='methylPipe')
load(gr_file)
resC <- getCposChr(GenoRanges=GR_chr20, seqContext='CG', chrseq=unmasked(Hsapiens[['chr20']]), nbins=3)
resd <- getCposDensity(GenoRanges=GR_chr20, Cpos= resC, nbins=3)
}
